/*====================== A MIDI SHARE TOOL  ( GRAME 92) =====================

NAME
      MidiTool -- a very simple MidiShare MPW tool

SYNOPSIS
      MidiTool [-dur <ms>]

DESCRIPTION
	"MidiTool" start a MidiShare session, wait for the amount of time
	specified (or 2000 ms) spinning the cursor, and then close the 
	MidiShare session

===============================================================================*/
 

#include <String.h>
#include <StdLib.h>
#include <Stdio.h>
#include <MidiShare.h>
#include <CursorCtl.h>



//----------------------------- utilities ---------------------------------

long lopt (char *argv[], char *name, long defaultVal) 
{
	int	i;
	for (i=0; argv[i]; i++) if (!strcmp(argv[i], name)) return atoi(argv[i+1]);
	return defaultVal;
}

void Wait (long d) 							
{	d += MidiGetTime();
	while (MidiGetTime() < d) SpinCursor(1);
}




//-------------------------------- main ------------------------------------

main( int, char *argv[])
{
	short 		ref;						// MidiShare client reference number
	
	InitCursorCtl(0);						// init MPW Spinning cursor
	ref = MidiOpen("\pMidiTool");			// open a MidiShare session
	Wait(lopt(argv, "-dur", 2000));			// wait 2000 ms or duration specified in cmd line
	MidiClose (ref);						// close the MidiShare session
}

