/********************************************************************************/
/*                             MIDI SKELETON									*/
/*------------------------------------------------------------------------------*/
/* MIDISHARE est un module logiciel conu spcialement pour permettre le fonc-	*/
/* tionnement et le dveloppement d'applications Midi dans un contexte multi-	*/
/* tches et temps rel.	 													*/
/* 																				*/
/* MIDISHARE prend en charge la plupart des problmes spcifiques lis au dve- */
/* loppement d'applications Midi: gestion des flux Midi, gestion du temps,		*/
/* gestion des tches. En outre, MIDISHARE permet le fonctionnement simultan	*/
/* sous Multi-Finder de ces applications, ainsi que l'tablissement de connec-	*/
/* tions Midi virtuelles entre celles-ci.										*/
/* 																				*/
/* Le programme prsent ici, fait partie d'une srie d'exemples  caractre	*/
/* pdagogique (enfin on espre !) sur la faon d'utiliser MIDISHARE.			*/
/* 																				*/
/* MIDI SKELETON est un squelette d'application Midi Share standard, charg		*/
/* uniquement d'un Midi Thru sans filtrage										*/
/*																				*/
/*------------------------------------------------------------------------------*/
/*		 GRAME 1987-92, Yann Orlarey et Herv Lequay							*/
/********************************************************************************/

/*
 derez -s CODE skeleton 
	{RIncludes}SysTypes.r 
	{RIncludes}Types.r 
	> skeleton.r
*/

#include "Types.r"
#include "SysTypes.r"


resource 'MENU' (128, "Apple", preload) {
	128,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"A propos de Skeleton", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (129, "File", preload) {
	129,
	textMenuProc,
	allEnabled,
	enabled,
	"Fichier",
	{	/* array: 1 elements */
		/* [1] */
		"Quitter", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (130, "Edit", preload) {
	130,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edition",
	{	/* array: 6 elements */
		/* [1] */
		"Annuler", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Couper", noIcon, "X", noMark, plain,
		/* [4] */
		"Copier", noIcon, "C", noMark, plain,
		/* [5] */
		"Coller", noIcon, "V", noMark, plain,
		/* [6] */
		"Effacer", noIcon, noKey, noMark, plain
	}
};

resource 'DLOG' (128, "Main") {
	{56, 32, 169, 372},
	documentProc,
	invisible,
	goAway,
	0x0,
	128,
	"Skeleton"
};

resource 'DLOG' (129, "About") {
	{95, 85, 192, 448},
	plainDBox,
	visible,
	goAway,
	0x0,
	129,
	""
};

resource 'DITL' (128, "Main") {
	{	/* array DITLarray: 1 elements */
		/* [1] */
		{49, 89, 63, 251},
		Picture {
			disabled,
			128
		}
	}
};

resource 'DITL' (500, "Errors") {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{52, 187, 73, 249},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{9, 52, 42, 255},
		StaticText {
			disabled,
			"Impossible de lancer ^0:\n^1."
		},
		/* [3] */
		{6, 8, 38, 40},
		Icon {
			disabled,
			500
		}
	}
};

resource 'DITL' (129, "About", preload) {
	{	/* array DITLarray: 1 elements */
		/* [1] */
		{-3, -3, 98, 364},
		Picture {
			enabled,
			129
		}
	}
};

resource 'ICON' (500, "MidiShare") {
	$"FFFF FFFF 8000 0001 8003 0001 8005 F001"
	$"801F 8F31 8363 80D9 8580 4379 8780 2C31"
	$"8300 30C1 8080 CD01 805B 1601 802C 1E01"
	$"803C 0C01 8018 0001 8000 0001 FFFF FFFF"
	$"B9C4 739D B9C4 739D B9C4 739D B9C4 739D"
	$"B9C4 739D B9C4 739D B9C4 739D B9C4 739D"
	$"9084 2109 9084 2109 9084 2109 9084 2109"
	$"9084 2109 9084 2109 9084 2109 FFFF FFFF"
};

resource 'ICON' (128) {
	$"FFFF FFFF 8000 0001 9E00 0001 B300 0001"
	$"B000 0001 B000 0001 B000 0001 B300 0001"
	$"9E00 0001 8000 0001 8000 0001 8102 0409"
	$"C991 2645 A162 858B 8100 0401 8102 0409"
	$"8100 0401 8102 0409 8100 0401 8102 0409"
	$"8100 0401 9F2A 7CA9 BB54 ED51 B322 CC89"
	$"BE54 F951 9C28 70A1 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 FFFF FFFF"
};

resource 'PICT' (128, "Main") {
	382,
	{0, 0, 14, 162},
	$"1101 A000 82A0 008E 0100 0A00 0000 0002"
	$"F002 4098 0016 0000 0000 000E 00A8 0000"
	$"0000 000E 00A2 0000 0000 000E 00A2 0001"
	$"1206 E007 0007 007E 70FD 0004 07E7 0000"
	$"70FB 0012 0660 0618 0318 C330 FD00 040C"
	$"3300 0030 FB00 1406 700E 1803 1981 30FD"
	$"0006 1813 0000 3000 20FD 0014 0670 0E00"
	$"0301 8130 FD00 0618 1300 0030 0060 FD00"
	$"1406 5816 0003 0180 30FD 0006 1803 0000"
	$"3000 60FD 0017 1358 1638 7F39 C033 87E3"
	$"99F0 1C03 187C 30F8 F878 E7FF 0017 154C"
	$"2618 C718 F835 C471 BB18 0F83 30C6 318C"
	$"618C 6B80 0017 154C 2619 8318 3E38 C031"
	$"C20C 03E3 6083 3106 6106 7180 0017 1546"
	$"4619 8318 0730 C0F1 860C 0073 C183 3306"
	$"6306 6180 0017 1546 4619 8318 0330 C731"
	$"87FC 0033 E1FF 33FE 6306 6180 0017 1543"
	$"8619 8319 0330 CC31 8600 1033 7180 3300"
	$"6306 6180 0017 1543 8619 8319 0330 CC31"
	$"8700 1033 39C0 3380 6304 6180 0017 1541"
	$"0618 C719 8630 CE71 8384 1863 1CE1 31C2"
	$"618C 6180 0017 15E1 0F3C 7BBC FC78 E7BB"
	$"C1F8 0FC7 8E7E 78FC 38F0 F1C0 00A0 008F"
	$"A000 83FF"
};

resource 'PICT' (129) {
	1696,
	{36, 37, 137, 404},
	$"0011 02FF 0C00 FFFF FFFF 0025 0000 0024"
	$"0000 0194 0000 0089 0000 0000 0000 0001"
	$"000A 0024 0025 0089 0194 0098 002E 0024"
	$"0025 0089 0194 0024 0025 0089 0194 0024"
	$"0025 0089 0194 0000 04D4 FF00 FE04 D4FF"
	$"00FE 04D4 FF00 FE04 D4FF 00FE 04D4 FF00"
	$"FE04 D4FF 00FE 04D4 FF00 FE04 D4FF 00FE"
	$"04D4 FF00 FE04 D4FF 00FE 04D4 FF00 FE04"
	$"D4FF 00FE 04D4 FF00 FE0C FDFF 009F FEFF"
	$"00FC DDFF 00FE 0E04 FFFF 80F8 1FFE FF00"
	$"C0DD FF00 FE12 04FF FC00 1F1F FEFF 00F8"
	$"FEFF 00DF E1FF 00FE 1204 FFF8 FF9F 1FFE"
	$"FF00 F8FE FF00 1FE1 FF00 FE12 04FF F1FF"
	$"DF1F FEFF 00F8 FEFF 001F E1FF 00FE 1204"
	$"FFF3 FFDF 1FFE FF00 F8FE FF00 1FE1 FF00"
	$"FE12 04FF E3FF DF1F FEFF 00F8 FEFF 001F"
	$"E1FF 00FE 1204 FFE3 FFFF 1FFE FF00 F8FE"
	$"FF00 1FE1 FF00 FE12 04FF E3FF FF1F FEFF"
	$"00F8 FEFF 001F E1FF 00FE 1711 FFE3 FFFF"
	$"1FE1 FF07 F8FF E0FE 00FF 01FF DE0F E6FF"
	$"00FE 1711 FFE1 FFFF 1FC7 FCF1 F8FF 9E38"
	$"00FC F87E 1807 E6FF 00FE 1711 FFF0 3FFF"
	$"1F9F F3F8 F8FE 7F1F 1FF9 FE38 13C3 E6FF"
	$"00FE 1711 FFF8 00FF 1F3F E3FC F8FC 7F9F"
	$"1FF3 FE1F 0FE1 E6FF 00FE 1711 FFFC 003F"
	$"1C7F E7FC 78FC FF8F 1FE7 FF1F 1FF1 E6FF"
	$"00FE 1711 FFFF 801F 19FF C7FC 78F8 FF8F"
	$"1FE7 FF0F 1FF1 E6FF 00FE 1711 FFFF FE0F"
	$"13FF C7FC 78F8 FF8F 1FC7 FF8F 1FF1 E6FF"
	$"00FE 16FE FF0E 0F01 FFC0 0078 F800 0F1F"
	$"C7FF 8F1F F1E6 FF00 FE16 FEFF 0E8F 10FF"
	$"C7FF F8F8 FFFF 1FC7 FF8F 1FF1 E6FF 00FE"
	$"16FE FF0E 8F18 7FC7 FFF8 F8FF FF1F C7FF"
	$"8F1F F1E6 FF00 FE17 11FF EFFF 8F1C 3FC7"
	$"FFF8 F8FF FF1F C7FF 8F1F F1E6 FF00 FE17"
	$"11FF EFFF 9F1E 1FC3 FFF8 F87F FF1F C3FF"
	$"9F1F F1E6 FF00 FE17 11FF EFFF 1F1F 0FE3"
	$"FFF8 FC7F FF1F E3FF 9F1F F1E6 FF00 FE17"
	$"11FF E7FF 3F1F 87E1 FEF8 FC3F DF1F E1FF"
	$"3F1F F1E6 FF00 FE17 11FF E3FC 7F1F C3F0"
	$"78F8 FE0F 1F0F F0FE 7F1F F1E6 FF00 FE17"
	$"11FF E000 FF1F E078 03F8 FF00 7F80 F87C"
	$"FF1F F1E6 FF00 FE18 12FF FC07 F803 F1FE"
	$"07C0 1FC0 FFC1 FE03 F803 F03F E7FF 00FE"
	$"04D4 FF00 FE04 D4FF 00FE 04D4 FF00 FE04"
	$"D4FF 00FE 04D4 FF00 FE04 D4FF 00FE 04D4"
	$"FF00 FE04 D4FF 00FE 1DED FF06 03FF FFF4"
	$"FFF8 3FFE FF0F C7F7 FFFE 7F37 F9FF EFFF"
	$"FCFF FC1F FFFE 2A0B FFFC 1FE0 C1FB E3C4"
	$"0FDE 38FB F9FF 06BB FFFF FEFF F7BF FEFF"
	$"0F3B EBFF FF7F BFFD FFD7 FFFE FFF3 DFFF"
	$"FE29 0BFF FBEF DEEE F5F3 CEEF 1DD7 73F9"
	$"FF05 BFFF FFFE FFEF FDFF 0F45 EBFF FF7F"
	$"BFFD FFD7 FFFE FFEF FFFF FE2A 0BFF F637"
	$"BFEE F5F3 CEFF DDD7 73F9 FF19 B7C9 9876"
	$"FBEF F40C 99E6 B5EB D1A3 73B6 9D9F D7A3"
	$"46E7 EFF0 C99E 2A0B FFF5 D7BF EEF5 F5AE"
	$"DFDD D76B F9FF 1987 E66F 66FF EFE2 EE66"
	$"DAAD DD8E 1D6D A46D 7FBB 1C3A DBEF EF66"
	$"6E2A 0BFF F5F7 BFE9 EEF5 AE1F DDD7 6BF9"
	$"FF19 B46E EC76 FFEF 178E EEC2 ABC1 DEBD"
	$"61B6 ECFF 83BD 7AC3 EFEF 6EEE 2A0B FFF5"
	$"D7BC 6BE0 F5AE DFDE 185B F9FF 19BF EEEB"
	$"76FF EFB7 6EEE DE83 BEDE BD6F B6ED 7F7D"
	$"BD7A DFEF EF6E EE2A 0BFF F637 BEED DF76"
	$"6EFF DFBE C1F9 FF19 BBEE EB76 FFF7 B76E"
	$"EEDF 7FBE DDBB 6FB6 EDBF 7DBB 76DF F7EF"
	$"6EEE 2A0B FFFB EFDE EEDF 766E EFDF 7DFB"
	$"F9FF 1903 C460 207B F863 0446 6383 1C43"
	$"8631 0060 CA38 870C 6378 10C4 661B 0BFF"
	$"FC1F E1C7 0E23 C40F 8CF3 F1ED FF01 DFBF"
	$"FCFF 01BF 7FFD FF00 FE0E E1FF 01DF BFFC"
	$"FF01 BF7F FDFF 00FE 0EE1 FF01 8F1F FCFF"
	$"011E 3FFD FF00 FE04 D4FF 00FE 02D3 0002"
	$"D300 02D3 0002 D300 02D3 0002 D300 02D3"
	$"0002 D300 02D3 0002 D300 02D3 0002 D300"
	$"02D3 0002 D300 02D3 0002 D300 02D3 0025"
	$"0100 01FB 0009 0180 0000 C082 2022 1E20"
	$"FC00 0B03 0800 0104 0000 0100 0001 80FD"
	$"0000 08FB 0024 0100 01FA 0008 8000 0100"
	$"C600 2021 20FC 0003 0100 0001 FE00 0001"
	$"FE00 0080 FD00 0008 FB00 2B27 0002 8580"
	$"7111 C598 F087 00E3 80AA 61E6 202C 38B9"
	$"C038 F1E1 1870 E38C 38B0 0F1C 4470 871E"
	$"2CC3 8B1C FB00 2B27 0002 8640 8912 2664"
	$"8888 8111 0092 2222 2032 44C2 2044 8911"
	$"0889 1104 44C8 1122 4488 8891 3324 4C88"
	$"FB00 2B27 0004 4440 88A1 E444 8888 8111"
	$"0082 2222 1E22 3C82 203C 8911 0880 F104"
	$"4488 1122 4488 8891 2224 4888 FB00 2B27"
	$"0004 4440 F842 2444 888F 8111 0082 2222"
	$"0122 4483 E044 8911 0881 1104 4488 113E"
	$"28F8 8891 2227 C888 FB00 2B27 000F E440"
	$"80A2 2444 8888 0111 0082 2222 0122 4482"
	$"0044 8911 0881 1104 4488 1120 2880 8891"
	$"2224 0888 FB00 2B27 0008 2440 8912 2444"
	$"8888 8111 0082 2222 2122 4482 2044 8911"
	$"0889 1104 4488 1122 1088 8891 2224 4888"
	$"FB00 2B27 0008 2440 7111 E444 F087 00E1"
	$"0082 21E2 1E22 3C81 C03C F1E1 0870 F0C4"
	$"3888 0F1C 1070 871E 2223 8886 FB00 0EF9"
	$"0000 80F4 0000 81F5 0000 10F7 000E F900"
	$"0080 F400 0081 F500 0010 F700 02D3 0002"
	$"D300 02D3 0002 D300 02D3 0002 D300 02D3"
	$"0002 D300 02D3 0002 D300 02D3 0002 D300"
	$"02D3 0000 00FF"
};

resource 'ALRT' (500, "Errors") {
	{100, 100, 183, 361},
	500,
	{	/* array: 4 elements */
		/* [1] */
		OK, invisible, silent,
		/* [2] */
		OK, invisible, silent,
		/* [3] */
		OK, invisible, silent,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'STR#' (500) {
	{	/* array StringArray: 3 elements */
		/* [1] */
		"MidiShare n'est pas install",
		/* [2] */
		"Trop d'applications MidiShare",
		/* [3] */
		"il faut au moins les ROMs 128K"
	}
};

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	32768,
	32768
};

resource 'BNDL' (128, purgeable) {
	'SklC',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		}
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	"SklC"
};

resource 'ICN#' (128, "Midi Skeleton") {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 8000 0001 9E00 0001 B300 0001"
		$"B000 0001 B000 0001 B000 0001 B300 0001"
		$"9E00 0001 8000 0001 8000 0001 8102 0409"
		$"C991 2645 A162 858B 8100 0401 8102 0409"
		$"8100 0401 8102 0409 8100 0401 8102 0409"
		$"8100 0401 9F2A 7CA9 BB54 ED51 B322 CC89"
		$"BE54 F951 9C28 70A1 8000 0001 8000 0001"
		$"8000 0001 8000 0001 8000 0001 FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'vers' (2) {
	0x1,
	0x50,
	release,
	0x0,
	verFrance,
	"1.50",
	" 1987-92 GRAME"
};

data 'SklC' (0) {
	$"0B56 6572 7369 6F6E 2031 2E35"                      /* .Version 1.5 */
};

resource 'ics#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF 8001 8001 8001 8889 EEEF 8889 8889"
		$"8889 9999 AAAB BBBB 9111 8001 8001 FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ics8' (128) {
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F869 ECF8 F8EC 69F8 F869 ECF8 F8FD"
	$"FD69 6900 ECEC EC00 6969 6900 ECEC ECFD"
	$"FD00 00F8 EC00 00F8 6900 00F8 EC00 00FD"
	$"FDF8 F8F8 EC00 F8F8 6900 F8F8 EC00 F8FD"
	$"FDF8 F8F8 EC00 F8F8 6900 F8F8 EC00 F8FD"
	$"FDF8 F8EC EC00 F869 6900 F8EC EC00 F8FD"
	$"FDF8 EC00 EC00 6900 6900 EC00 EC00 69FD"
	$"FDF8 ECEC EC00 6969 6900 ECEC EC00 69FD"
	$"FDF8 F8EC 00F8 F869 00F8 F8EC 00F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
};

resource 'icl8' (128) {
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8FF FFFF FFF8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 FFFF F8F8 FFFF F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 FFFF F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 FFFF F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 FFFF F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 FFFF F8F8 FFFF F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8FF FFFF FFF8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8EC F8F8 F8F8 F8F8 69F8"
	$"F8F8 F8F8 F8EC F8F8 F8F8 F8F8 69F8 F8FD"
	$"FD69 F8F8 69F8 F8EC ECF8 F8EC F8F8 6969"
	$"F8F8 69F8 F8EC ECF8 F8EC F8F8 6969 F8FD"
	$"FD00 6969 0000 F8EC 00EC EC00 00F8 6900"
	$"6969 0000 F8EC 00EC EC00 00F8 6900 69FD"
	$"FD00 0000 F8F8 F8EC 0000 00F8 F8F8 6900"
	$"0000 F8F8 F8EC 0000 00F8 F8F8 6900 00FD"
	$"FDF8 F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900"
	$"F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900 F8FD"
	$"FDF8 F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900"
	$"F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900 F8FD"
	$"FDF8 F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900"
	$"F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900 F8FD"
	$"FDF8 F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900"
	$"F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900 F8FD"
	$"FDF8 F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900"
	$"F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900 F8FD"
	$"FDF8 F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900"
	$"F8F8 F8F8 F8EC 00F8 F8F8 F8F8 6900 F8FD"
	$"FDF8 F8EC ECEC ECEC 00F8 6969 6969 6900"
	$"F8EC ECEC ECEC 00F8 6969 6969 6900 F8FD"
	$"FDF8 ECEC EC00 ECEC 0069 6969 0069 6900"
	$"ECEC EC00 ECEC 0069 6969 0069 6900 F8FD"
	$"FDF8 ECEC 0000 ECEC 0069 6900 0069 6900"
	$"ECEC 0000 ECEC 0069 6900 0069 6900 F8FD"
	$"FDF8 ECEC ECEC EC00 F869 6969 6969 00F8"
	$"ECEC ECEC EC00 F869 6969 6969 00F8 F8FD"
	$"FDF8 F8EC ECEC 00F8 F8F8 6969 6900 F8F8"
	$"F8EC ECEC 00F8 F8F8 6969 6900 F8F8 F8FD"
	$"FDF8 F800 0000 F8F8 F8F8 0000 00F8 F8F8"
	$"F800 0000 F8F8 F8F8 0000 00F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8"
	$"F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
};

resource 'icl4' (128) {
	$"EEEE EEEE EEEE EEEE EEEE EEEE EEEE EEEE"
	$"EDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDF FFFD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDFF DDFF DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDFF DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDFF DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDFF DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDFF DDFF DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDF FFFD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDD DDD6 DDDD DD4D DDDD D6DD DDDD 4DDE"
	$"E4DD 4DD6 6DD6 DD44 DD4D D66D D6DD 44DE"
	$"EC44 CCD6 C66C CD4C 44CC D6C6 6CCD 4C4E"
	$"ECCC DDD6 CCCD DD4C CCDD D6CC CDDD 4CCE"
	$"EDDD DDD6 CDDD DD4C DDDD D6CD DDDD 4CDE"
	$"EDDD DDD6 CDDD DD4C DDDD D6CD DDDD 4CDE"
	$"EDDD DDD6 CDDD DD4C DDDD D6CD DDDD 4CDE"
	$"EDDD DDD6 CDDD DD4C DDDD D6CD DDDD 4CDE"
	$"EDDD DDD6 CDDD DD4C DDDD D6CD DDDD 4CDE"
	$"EDDD DDD6 CDDD DD4C DDDD D6CD DDDD 4CDE"
	$"EDD6 6666 CD44 444C D666 66CD 4444 4CDE"
	$"ED66 6066 C444 044C 6660 66C4 4404 4CDE"
	$"ED66 0066 C440 044C 6600 66C4 4004 4CDE"
	$"ED66 666C D444 44CD 6666 6CD4 4444 CDDE"
	$"EDD6 66CD DD44 4CDD D666 CDDD 444C DDDE"
	$"EDDC CCDD DDCC CDDD DCCC DDDD CCCD DDDE"
	$"EDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDE"
	$"EEEE EEEE EEEE EEEE EEEE EEEE EEEE EEEE"
};

resource 'ics4' (128) {
	$"EEEE EEEE EEEE EEEE EDDD DDDD DDDD DDDE"
	$"EDDD DDDD DDDD DDDE EDDD DDDD DDDD DDDE"
	$"EDD4 6DD6 4DD4 6DDE E44C 666C 444C 666E"
	$"ECCD 6CCD 4CCD 6CCE EDDD 6CDD 4CDD 6CDE"
	$"EDDD 6CDD 4CDD 6CDE EDD6 6CD4 4CD6 6CDE"
	$"ED60 6C40 4C60 6C4E ED66 6C44 4C66 6C4E"
	$"EDD6 CDD4 CDD6 CDDE EDDD DDDD DDDD DDDE"
	$"EDDD DDDD DDDD DDDE EEEE EEEE EEEE EEEE"
};

data 'cicn' (128) {
	$"0000 0000 8010 0000 0000 0020 0020 0000"            /* .......... . .. */
	$"0000 0000 0000 0048 0000 0048 0000 0000"            /* .......H...H.... */
	$"0004 0001 0004 0000 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 0004 0000 0000 0020 0020"            /* ............. .  */
	$"0000 0000 0004 0000 0000 0020 0020 0000"            /* ........... . .. */
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF 8000 0001 9E00 0001 B300"            /* ............. */
	$"0001 B000 0001 B000 0001 B000 0001 B300"            /* ............ */
	$"0001 9E00 0001 8000 0001 8000 0001 8102"            /* ............ */
	$"0409 C991 2645 A162 858B 8100 0401 8102"            /* .ɑ&Eb.... */
	$"0409 8100 0401 8102 0409 8100 0401 8102"            /* .Ɓ.....Ɓ.... */
	$"0409 8100 0401 9F2A 7CA9 BB54 ED51 B322"            /* .Ɓ...*|T.Q" */
	$"CC89 BE54 F951 9C28 70A1 8000 0001 8000"            /* ̉T.Q(p.... */
	$"0001 8000 0001 8000 0001 8000 0001 FFFF"            /* ............. */
	$"FFFF 0000 0000 0000 0005 0000 FFFF FFFF"            /* ................ */
	$"FFFF 0001 0000 0000 DDDD 0002 9999 0000"            /* .............. */
	$"6666 0003 AAAA AAAA AAAA 0004 2222 2222"            /* ff...."""" */
	$"2222 000F 0000 0000 0000 4444 4444 4444"            /* ""........DDDDDD */
	$"4444 4444 4444 4444 4444 4333 3333 3333"            /* DDDDDDDDDDC33333 */
	$"3333 3333 3333 3333 3334 433F FFF3 3333"            /* 3333333334C?..33 */
	$"3333 3333 3333 3333 3334 43FF 33FF 3333"            /* 3333333334C.3.33 */
	$"3333 3333 3333 3333 3334 43FF 3333 3333"            /* 3333333334C.3333 */
	$"3333 3333 3333 3333 3334 43FF 3333 3333"            /* 3333333334C.3333 */
	$"3333 3333 3333 3333 3334 43FF 3333 3333"            /* 3333333334C.3333 */
	$"3333 3333 3333 3333 3334 43FF 33FF 3333"            /* 3333333334C.3.33 */
	$"3333 3333 3333 3333 3334 433F FFF3 3333"            /* 3333333334C?..33 */
	$"3333 3333 3333 3333 3334 4333 3333 3333"            /* 3333333334C33333 */
	$"3333 3333 3333 3333 3334 4333 3333 3333"            /* 3333333334C33333 */
	$"3333 3333 3333 3333 3334 4333 3331 3333"            /* 3333333334C33133 */
	$"3323 3333 3133 3333 2334 4233 2331 1331"            /* 3#331333#4B3#1.1 */
	$"3322 3323 3113 3133 2234 4022 0031 0110"            /* 3"3#1.13"4@".1.. */
	$"0320 2200 3101 1003 2024 4000 3331 0003"            /* . ".1... $@.31.. */
	$"3320 0033 3100 0333 2004 4333 3331 0333"            /* 3 .31..3 .C331.3 */
	$"3320 3333 3103 3333 2034 4333 3331 0333"            /* 3 331.33 4C331.3 */
	$"3320 3333 3103 3333 2034 4333 3331 0333"            /* 3 331.33 4C331.3 */
	$"3320 3333 3103 3333 2034 4333 3331 0333"            /* 3 331.33 4C331.3 */
	$"3320 3333 3103 3333 2034 4333 3331 0333"            /* 3 331.33 4C331.3 */
	$"3320 3333 3103 3333 2034 4333 3331 0333"            /* 3 331.33 4C331.3 */
	$"3320 3333 3103 3333 2034 4331 1111 0322"            /* 3 331.33 4C1..." */
	$"2220 3111 1103 2222 2034 4311 1011 0222"            /* " 1..."" 4C...." */
	$"0220 1110 1102 2202 2034 4311 0011 0220"            /* . ....". 4C....  */
	$"0220 1100 1102 2002 2034 4311 1110 3222"            /* . .... . 4C...2" */
	$"2203 1111 1032 2222 0334 4331 1103 3322"            /* "....2"".4C1..3" */
	$"2033 3111 0333 2220 3334 4330 0033 3300"            /*  31..3" 34C0.33. */
	$"0333 3000 3333 0003 3334 4333 3333 3333"            /* .30.33..34C33333 */
	$"3333 3333 3333 3333 3334 4333 3333 3333"            /* 3333333334C33333 */
	$"3333 3333 3333 3333 3334 4333 3333 3333"            /* 3333333334C33333 */
	$"3333 3333 3333 3333 3334 4333 3333 3333"            /* 3333333334C33333 */
	$"3333 3333 3333 3333 3334 4444 4444 4444"            /* 3333333334DDDDDD */
	$"4444 4444 4444 4444 4444"                           /* DDDDDDDDDD */
};

