{}
{                        MIDI SKELETON											}
{------------------------------------------------------------------------------}
{ MIDISHARE est un module logiciel conu spcialement pour permettre le fonc-	}
{ tionnement et le dveloppement d'applications Midi dans un contexte multi-	}
{ tches et temps rel.	 													}
{ 																				}
{ MIDISHARE prend en charge la plupart des problmes spcifiques lis au dve- }
{ loppement d'applications Midi: gestion des flux Midi, gestion du temps,		}
{ gestion des tches. En outre, MIDISHARE permet le fonctionnement simultan	}
{ sous Multi-Finder de ces applications, ainsi que l'tablissement de connec-	}
{ tions Midi virtuelles entre celles-ci.										}
{ 																				}
{ SKELETON est un exemple d'application MidiShare minimale qui peut tre		}
{ utilise comme base de dveloppement pour de nouvelles applications.			}
{ Par dfaut, l'application renvoie tous les vnements qu'elle reoit, sans	}
{ aucune modification.															}
{																				}
{ Les points qui peuvent tre facilement modifis sont les suivants :			}
{																				}
{ - ReceiveEvents : qui traite tous les vnements reus et qui ralise ici 	}
{   un simple MidiThru.														}
{																				}
{ - La constante wantRealTime : quand elle vaut 1, ReceiveEvents est appele	}
{   sous interruption et fonctionne donc en temps rel, mais ne peut pas		}
{   utiliser les appels  la Toolbox; quand elle vaut 0, ReceiveEvents est 	}
{   appele dans la boucle principale et peut donc utiliser la toolbox.		}
{																				}
{ - La constante wantFilter : quand elle vaut 1, un filtre sur les entres  	}
{   Midi est install, quand elle vaut 0, aucun filtre n'est install et 		}
{   l'application reoit tous les vnements.									}
{																				}
{ - InstallFilter : qui configure le filtre d'entre							}
{																				}
{ - La resource de dialogue 128 qui dfinit la fentre de l'application		}
{																				}
{																				}
{------------------------------------------------------------------------------}
{		 GRAME 1987-92, Yann Orlarey et Herv Lequay 							}
{}

{$D+} { MacsBug symbols on }
{$R-} { No range checking  }

Program SKELETON;

USES	Memtypes, Quickdraw, OSIntf, ToolIntf, PackIntf, Traps, MidiShareUnit;

const	AppleID	= 128;	AppleMenu	= 1;
		FileID	= 129;	FileMenu	= 2;
		EditID	= 130;	EditMenu	= 3;
			UndoI	= 1;	CutI	= 3;	CopyI	= 4;	PasteI	= 5;	ClearI	= 6;
		
		WindowID	= 128; 
		AboutID		= 129;
		AlertID		= 500;
		
		resumeMask	= $01;										{ suspend/resume mask				}
		
		wantRealTime= true;										{ je veux du temps rel				}
		wantFilter	= false;									{ sans filtrage des vnements		}
		
var	
	myRefNum:				integer;							{ numro d'appl. Midi				}
	myFilter:				TFilter;							{ filtre d'vnements				}
	myWindow:	 			windowPtr;							{ fentre							}

	doneFlag:				boolean;							{ flag d'arrt						}
	
	gMac:					SysEnvRec;							{ machine							}
	eventPending:			boolean;							{ vrai si vnement en attente		}
	hasWNE:					boolean;							{ vrai si WaitNextEvent implment	}
	foreGround:				boolean;							{ vrai si en foreGround				}

	myEvent:				eventRecord;						{ pour la main event loop			}
	theChar:				char;								{ pour la gestion des touches		}
	dragRect:				rect;								{ rect de dplacement de fentre	}
	myMenus:				array[AppleMenu..EditMenu] of MenuHandle;
																{ les menus							}

	

(********************************************************************************)
(* 								UTILITAIRES										*)
(*------------------------------------------------------------------------------*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Function TRAPAVAILABLE (tNumber: integer; tType: trapType): boolean;
(*	Vrification de l'implmentation d'une trappe								*)
begin
	TrapAvailable:= NGetTrapAddress(tNumber,tType) <> GetTrapAddress(_Unimplemented)
end;

{$S Main}
Function ISAPPWINDOW (aWind: windowPtr): boolean;
(* vrifie si la fentre appartient  l'application								*)
begin
	if aWind = nil then
		IsAppWindow:= false
	else 
		IsAppWindow:= windowPeek(aWind)^.windowKind >= 0
end;

{$S Main}
Function ISDAWINDOW (aWind: windowPtr): boolean;
(* vrifie si la fentre appartient  un accessoire de bureau					*)
begin
	if aWind = nil then
		IsDAWindow:= false
	else 
		IsDAWindow:= windowPeek(aWind)^.windowKind < 0
end;

{$S Main}
Procedure CenterRectOnScreen (var aRect: Rect);
(* Centre un rectangle global sur l'cran principal (dragRect)					*)
var	screenSize	: Point;
	rectSize	: Point;
begin
	with dragRect do
		SetPt(screenSize,right - left,bottom - top);
	with aRect do begin
		SetPt(rectSize,right - left,bottom - top);
		left:= dragRect.left + (screenSize.h - rectSize.h) div 2;
		top:= dragRect.top + (screenSize.v - rectSize.v) div 5;
		topLeft:= point(PinRect(dragRect,topLeft));
		right:= left + rectSize.h;
		bottom:= top + rectSize.v;
		end;
end;

{$S Main}
Function GetNewCenteredDialog (dialogID: integer): DialogPtr;
(* Affiche une fentre de dialogue au centre de l'cran							*)
var	dlogTemplate	: DialogTHndl;
begin
	GetNewCenteredDialog := nil;
	dlogTemplate := DialogTHndl(GetResource('DLOG', dialogID));
	if dlogTemplate <> nil then begin
		CenterRectOnScreen(dlogTemplate^^.boundsRect);
		GetNewCenteredDialog:= GetNewDialog(dialogID, nil, pointer(-1));
		end
	else SysBeep(2)												{ At least give some indication }
end;

{$S Main}
Procedure AlertUser (alertID: integer);
(* Affiche une alerte au centre de l'cran										*)
var	alrtTemplate	: AlertTHndl;
	temp			: integer;
begin
	alrtTemplate := AlertTHndl(GetResource('ALRT', alertID));
	if alrtTemplate <> nil then begin
		SetCursor(arrow);
		CenterRectOnScreen(alrtTemplate^^.boundsRect);
		temp:= Alert(alertID,nil)
		end
	else SysBeep(2) 											{ At least give some indication		}
end;


(*=============================== MidiShare Part ===============================*)


(********************************************************************************)
(* 								RECEIVE EVENTS									*)
(*------------------------------------------------------------------------------*)
(* Cette procdure traite tous les vnements reus. Elle peut tre appele		*)
(* "manuellement" (wantRealTime 0) dans la boucle principale de l'application	*)
(* s'il n'y a pas de contraintes temps rel sur la rception.					*)
(* 																				*)
(* Dans le cas contraire (wantRealTime 1), grce  MidiSetRcvAlarm, la routine 	*)
(* peut tre appele automatiquement par MidiShare, sous interruptions, chaque 	*) 
(* fois que l'application reoit de nouveaux vnements (voir SetupMidi). 		*)
(* 																				*)
(* Dans le code ci dessous, ReceiveEvents ralise un simple MidiThru sans		*)
(* aucun traitement. 															*)
(* 																				*)
(* ReceiveEvents doit obligatoirement comporter un paramtre, qui est le 		*)
(* numro de rfrence MidiShare de l'application.								*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		refNum:	numro de rfrence MidiShare de l'application.					*)
(* 																				*)
(********************************************************************************)

{$ Main}
Procedure RECEIVEEVENTS (refNum: integer);
var	e:	midiEvPtr;
	n: 	longint;
begin
	n := midiCountEvs(refNum);							{ compte les vnements reus				}
	while n > 0 do begin								{ Pour chaque vnement :					}
		e := midiGetEv(refNum);							{  on rcupre l'vnement reu				}
		MidiSend(refNum,e);								{  et on le renvoie sans modification		}
		n := n-1										{  un de moins  traiter					}
		end
end;
						

(********************************************************************************)
(*							INSTALL FILTER										*)
(*------------------------------------------------------------------------------*)
(* Cette procdure dfinit les valeurs du filtre de l'application. Un filtre 	*)
(* est compos de trois parties, qui sont trois tableaux de boolens :			*) 
(* 																				*)
(*		un tableau de 256 bits pour les ports Midi accepts						*)
(*		un tableau de 256 bits pour les types d'vnements accepts				*)
(*		un tableau de  16 bits pour les canaux Midi accepts					*)
(* 																				*)
(* Dans le code ci dessous, le filtre est paramtr pour accepter n'importe		*)
(* quel type d'vnement. 														*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$ Initialize}
Procedure INSTALLFILTER;
var	i:	integer;
begin
	for i:= 0 to 255 do begin
		myFilter.evType[i]:= true;						{ accepte tous les types d'vnements		}
		myFilter.port[i]:= true							{ en provenance de tous les ports			}
		end;
											
	for i:= 0 to 15 do
		myFilter.channel[i]:= true;						{ et sur tous les canaux Midi				}
		
	MidiSetFilter(myRefNum,@myFilter)		   			{ installe le filtre						}
end;


(********************************************************************************)
(* 								APPL ALARM										*)
(*------------------------------------------------------------------------------*)
(* ALARM est la procdure passe  MidiShare comme alarme de changement de sta-	*)
(* tut des appl. Midi ou des ports. Comme il est possible qu'elle soit appele	*)
(* sous interruptions, elle ne peut provoquer d'appel  des routines qui utili-	*)
(* sent le Memory Manager. Elle positionne seulement des flags, la Main Event  	*)
(* Loop se chargeant d'appeler MAINALARM si ces flags sont positionns. 		*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		refnum: numro de l'application (de Midi Connection)					*)
(*		code:	HiWrd = refnum de l'application concerne						*)
(*				LoWrd = code de la modification intervenue						*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure APPLALARM (refnum: integer; code: longint);
begin	
	case LoWrd(code) of
		MIDIOpenAppl		:	;		{ ouverture d'une application				}
		MIDICloseAppl		:	;		{ fermeture d'une application				}
		MIDIChgName			:	;		{ changement de nom d'une application		}
		MIDIChgConnect		:	;		{ modification d'une connexion				}
		MIDIOpenModem		:	;		{ ouverture du port Modem					}
		MIDICloseModem		:	;		{ fermeture du port Modem					}
		MIDIOpenPrinter		:	;		{ ouverture du port Printer					}
		MIDIClosePrinter	:	;		{ fermeture du port Printer					}
		end;
end;


(********************************************************************************)
(* 								SETUP MIDI										*)
(*------------------------------------------------------------------------------*)
(* Vrifie la prsence de MidiShare, la possibilit d'ouverture Midi, et		*)
(* installe la procdure d'alarme qui sera appele par MidiShare lors des chan-	*)
(* gements de statut des applications ou des ports.								*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Procedure SETUPMIDI;
var	name:		str255;
	apRefNum:	integer;
	apParam:	Handle;
	aRefNum:	integer;

	Procedure FAILSETUP (strIndex: integer);
	var	msgStr:	str255;
	begin
		GetIndString (msgStr,AlertID,strIndex);			{ message d'alerte suivant erreur	}
		ParamText(name,msgStr,'','');
		AlertUser(AlertID);
		ExitToShell										{ et quitte							}
	end;
	
begin
	GetAppParms(name,apRefNum,apParam);					{ rcuprer le nom d'application	}
	if not MidiShare then FailSetUp(1);					{ MidiShare n'est pas install		}
		
	myRefNum:= MidiOpen(name);							{ ouverture en Midi					}
	if myRefNum = MidiErrSpace then FailSetUp(2);		{ impossible, plus de place			}
	
	if wantRealTime then begin
		{MidiSetApplAlarm(myRefNum,@ApplAlarm);}		{ dfinit la tche temps-rel de contexte	}
		MidiSetRcvAlarm(myRefNum,@ReceiveEvents)		{ dfinit la tche temps-rel de rception	}
		end;
	if wantFilter then		
		InstallFilter;									{ installe un filtre si ncessaire			}
	
	MidiConnect(0,myRefNum,true);						{ connection avec les ports Midi d'entres	}
	MidiConnect(myRefNum,0,true)						{ connection avec les ports Midi de sortie	}
end;
			

(********************************************************************************)
(* 								DO IDLE											*)
(*------------------------------------------------------------------------------*)
(* Execution des diffrentes tches Midi : reception des vnements Midi si		*)
(* cela n'est pas fait sous interruptions; Excution des tches diffres en	*)
(* attente (tches cres par MidiDTask).										*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure DOIDLE;
var	n:	longint;
begin
	if not wantRealTime then
		ReceiveEvents(myRefNum);
	for n:= 1 to MidiCountDTasks(myRefNum) do
		MidiExec1DTask(myRefNum)
end;


(*=============================== Macintosh Part ===============================*)

(********************************************************************************)
(* 								SET UP MENUS									*)
(*------------------------------------------------------------------------------*)
(* Installation de la barre de menus										  	*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Procedure SETUPMENUS;
var	i:	integer;
begin	
	myMenus[AppleMenu] := GetMenu(AppleID);						{ menu Pomme						}
	AddResMenu(myMenus[AppleMenu],'DRVR');						{ ajout des accessoires de bureau	}
	myMenus[FileMenu] := GetMenu(FileID);						{ menu Fichier						}
	myMenus[EditMenu] := GetMenu(EditID);						{ menu Edit							}
	for i := AppleMenu to EditMenu do
		InsertMenu(myMenus[i], 0);
	DrawMenuBar													{ affiche la barre des menus		}
end;
			

(********************************************************************************)
(* 								SETUP WINDOW									*)
(*------------------------------------------------------------------------------*)
(* Ouvre la fentre																*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Procedure SETUPWINDOW;
var	r	: rect;
begin	
	with screenBits.bounds do									{ rect max de dplacmt de fentre	}
		SetRect(dragRect, 4, 24, right - 4, bottom - 4);
	myWindow := GetNewDialog(WindowID,nil,pointer(-1));
	SetPort(myWindow);
	r:= myWindow^.portRect;
	with r do begin
		LocalToGlobal(topLeft);
		LocalToGlobal(botRight)
		end;
	if not RectInRgn(r,GetGrayRgn) then begin					{ rect fentre hors crans :		}
		CenterRectOnScreen(r);									{ le centrer sur l'cran principal	}
		MoveWindow(myWindow,r.left,r.top,true)
		end;
	ShowWindow(myWindow)
end;

{$S Main}
Procedure SAVEWINDOWPOS;
(* Sauvegarde dans la ressource DLOG de l'application la position de la fentre	*)
type	rectPtr  = 	^rect;
		rectHdle =	^rectPtr;
var	windHdle:	handle;
begin
	windHdle:= Get1Resource('DLOG',WindowID);
	rectHdle(windHdle)^^:= windowPeek(myWindow)^.contRgn^^.rgnBBox;
	ChangedResource(windHdle);
	if ResError = noErr then
		WriteResource(windHdle)
end;
	

(********************************************************************************)
(* 								INITIALIZE										*)
(*------------------------------------------------------------------------------*)
(* Initialisations gnrales (hasWNE, foreGround, managers, fentre, Midi)		*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Procedure INITIALIZE;
var	err:	OSErr;
begin
	err:= SysEnvirons(1,gMac);
	hasWNE:= (gMac.machineType >= 0) & TrapAvailable(_WaitNextEvent,ToolTrap);
		
	InitGraf(@thePort);											{ initialisations standard			}
	InitFonts;
	InitWindows;
	InitMenus;
	TEInit;
	InitDialogs(NIL);
	InitCursor;
	SetUpMenus;													{ mise en place menus				}
	SetUpMidi;													{ ouverture MidiShare				}
	SetUpWindow;												{ initialisations fentre et listes	}
end;


(********************************************************************************)
(* 								ADJUST MENUS									*)
(*------------------------------------------------------------------------------*)
(* Ajustement de la barre de menus suivant la fentre de premier plan, juste	*)
(* lors d'un click dans la barre des menus										*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 							 													*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure ADJUSTMENUS;
begin
	if IsAppWindow(FrontWindow) then begin
		DisableItem(myMenus[EditMenu],UndoI);
		DisableItem(myMenus[EditMenu],CutI);
		DisableItem(myMenus[EditMenu],CopyI);
		DisableItem(myMenus[EditMenu],PasteI);
		DisableItem(myMenus[EditMenu],ClearI)
		end
	else
	if IsDAWindow(FrontWindow) then begin
		EnableItem(myMenus[EditMenu],UndoI);
		EnableItem(myMenus[EditMenu],CutI);
		EnableItem(myMenus[EditMenu],CopyI);
		EnableItem(myMenus[EditMenu],PasteI);
		EnableItem(myMenus[EditMenu],ClearI)
		end
end;
			

(********************************************************************************)
(* 								DO COMMAND										*)
(*------------------------------------------------------------------------------*)
(* Gre les menus: Pomme (About), File (Quit)									*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		mResult: numro de menu et d'item retourns par MenuSelect et MenuKey	*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure DOCOMMAND ( mResult: LONGINT);
var	theItem:	integer;
	name:		str255;
	sysEdit:	boolean;
	
	Procedure SHOWABOUT;
	var	myDialog	: dialogPtr;
		hit			: integer;
	begin
		myDialog:= GetNewCenteredDialog(AboutID);
		if myDialog <> nil then begin
			ModalDialog(nil,hit);
			DisposDialog(myDialog);
			end
	end;
			
begin	
	theItem := LoWord(mResult);
	case HiWord(mResult) of
		AppleID:												{ menu Pomme						}
			if theItem <> 1 then begin
				GetItem(myMenus[AppleMenu], theItem, name);
				theItem := OpenDeskAcc(name)  end
			else ShowAbout;
		FileID:													{ menu File							}
			doneFlag := true;
		EditID:													{ menu Edit: uniquement pour DAs	}
			sysEdit := SystemEdit(theItem-1);
		end;
	HiliteMenu(0)
end;
		
		
(********************************************************************************)
(* 								TRACK DIALOG									*)
(*------------------------------------------------------------------------------*)
(* Procdure charge du suivi de la souris lors d'un click dans contenu			*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		window:	pointeur sur la fentre de dialogue.							*)
(*		where:	point o la souris a t clique.								*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure TRACKDIALOG (window: windowPtr; where: point);
begin
	SetPort(window);
	GlobalToLocal(where);										{ conversion du point en local		}
end;

		
(********************************************************************************)
(* 								DO MOUSE DOWN									*)
(*------------------------------------------------------------------------------*)
(* Gre les clicks souris														*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		anEvent: l'vnement													*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure DOMOUSEDOWN (anEvent: eventRecord);
var	whichWind:	windowPtr;
	part:		integer;
begin
	part:= FindWindow(anEvent.where, whichWind);
	case part of
		inMenuBar:		begin
						AdjustMenus;
						DoCommand(MenuSelect(anEvent.where))
						end;
		inSysWindow:	SystemClick(anEvent,whichWind);
		inDrag: 		DragWindow(whichWind,anEvent.where,dragRect);
		inGoAway:		doneFlag:= TrackGoAway(whichWind,anEvent.where);
		inContent:		if whichWind <> FrontWindow then
							SelectWindow(whichWind)
						else
							if IsAppWindow(whichWind) then
								TrackDialog(whichWind,anEvent.where);
		end
end;


(********************************************************************************)
(* 								ADJUST CURSOR									*)
(*------------------------------------------------------------------------------*)
(* Ajuste le curseur suivant rgion et fentre									*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure ADJUSTCURSOR;
begin
	if foreGround and IsAppWindow(FrontWindow) then
		SetCursor(arrow)
end;


(********************************************************************************)
(* 								CLOSE WINDOWS									*)
(*------------------------------------------------------------------------------*)
(* Pour terminer correctement l'application: fermeture de toutes les fentres	*)
(* (application et DA's)														*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure CLOSEWIND (aWind: windowPtr);
(* ferme une fentre															*)
begin
	if IsDAWindow(aWind) then
		CloseDeskAcc(windowPeek(aWind)^.windowKind)
	else if IsAppWindow(aWind) then
		DisposeWindow(aWind)
end;

Procedure CLOSEALLWINDS;
(* ferme toutes les fentres													*)
var	window:	windowPtr;
begin
	repeat
		window:= FrontWindow;
		if window <> nil then
			CloseWind(window);
	until window = nil;
end;


Procedure _DataInit;		EXTERNAL;

(********************************************************************************)
(* 							Corps Principal										*)
(*------------------------------------------------------------------------------*)
(* Initialisation des managers, ouverture fentre, initialisations diverses	et	*)
(* tutti quanti, boucle principale.												*)
(* 																				*)
(********************************************************************************)

{$S Main}
begin
	UnLoadSeg(@_DataInit);
	MaxApplZone;
	Initialize;
	UnLoadSeg(@Initialize);
	
	DoneFlag:=false;											{ flag de terminaison				}
	repeat														{ boucle principale typique			}
		if hasWNE then
			eventPending:= WaitNextEvent(everyEvent, myEvent, 0, nil)
																{ no sleep, no mouseRgn				}
		else begin
			SystemTask;
	 		eventPending:= GetNextEvent(everyEvent, myEvent)
		end;
		AdjustCursor;											{ si  curseurs ou mouseRgn, ici	}
		with myEvent do
			case what of
				nullEvent:
					DoIdle;										{ do Idle							}
				{
				activateEvt:
					if IsAppWindow(windowPtr(message)) then;
						if BAnd(modifiers,activeFlag) <> 0 then
						else
				}
				osEvt:
					case BSR(message,24) of
						suspendResumeMessage:
							begin
							foreGround:= BAnd(message,resumeMask) <> 0;
							{
							if IsAppWindow(FrontWindow) then
							}
							end;
						mouseMovedMessage:
							DoIdle								{ do Idle							}
					end;
				keyDown, autoKey:
					begin
						theChar:= chr(BAnd(message,charCodeMask));
						IF BAnd(modifiers, cmdKey) <> 0 then begin
							AdjustMenus;
							DoCommand(MenuKey(theChar))
							end
					end;
				mouseDown:
					DoMouseDown(myEvent);
				updateEvt:
					if IsAppWindow(windowPtr(message)) then begin
						BeginUpdate(myWindow);
						if not EmptyRgn(myWindow^.visRgn) then begin
							SetPort(myWindow);
							DrawDialog(myWindow)
							end;
						EndUpdate(myWindow)
					end
				end
	until doneFlag;
	MidiClose(myRefNum);												{ fermeture MidiShare 			}
	SaveWindowPos;
	CloseAllWinds;
	ExitToShell
end.
