/********************************************************************************/
/*                                  DISPLAY                                     */
/*------------------------------------------------------------------------------*/
/* 																				*/
/* Le programme DISPLAY prsent ici, fait partie d'une srie d'exemples  		*/
/* caractre pdagogique sur la faon d'utiliser MIDISHARE.						*/
/* 																				*/
/* DISPLAY affiche en permanence et sans aucun filtrage les vnements Midi 	*/
/* reus. Les informations affiches sont la date : en heures, minutes, secondes*/
/* et millimes, la provenance : port et canal Midi, le type d'vnement : note	*/
/* keyOn, etc... et les donnes complmentaires : hauteur, vlocit, etc...		*/
/*------------------------------------------------------------------------------*/
/*		 GRAME 1989/90 Yann Orlarey et Herv Lequay							*/
/********************************************************************************/

/*
	 derez -s CODE msDisplay 
	{RIncludes}SysTypes.r 
	{RIncludes}Types.r 
	> msDisplay.r
*/

#include "Types.r"
#include "SysTypes.r"

resource 'MENU' (128, "Apple", preload) {
	128,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"A propos de msDisplay", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (129, "File", preload) {
	129,
	textMenuProc,
	allEnabled,
	enabled,
	"Fichier",
	{	/* array: 1 elements */
		/* [1] */
		"Quitter", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (130, "Edit", preload) {
	130,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Annuler", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Couper", noIcon, "X", noMark, plain,
		/* [4] */
		"Copier", noIcon, "C", noMark, plain,
		/* [5] */
		"Coller", noIcon, "V", noMark, plain,
		/* [6] */
		"Effacer", noIcon, noKey, noMark, plain
	}
};

resource 'DLOG' (128, "Main") {
	{53, 49, 341, 335},
	noGrowDocProc,
	invisible,
	goAway,
	0x0,
	128,
	"msDisplay"
};

resource 'DLOG' (129, "About") {
	{24, 30, 338, 485},
	plainDBox,
	visible,
	goAway,
	0x0,
	129,
	""
};

resource 'DITL' (128, "Main") {
	{	/* array DITLarray: 1 elements */
		/* [1] */
		{4, 4, 281, 277},
		Picture {
			disabled,
			128
		}
	}
};

resource 'DITL' (500, "Errors") {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{52, 187, 73, 249},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{9, 52, 42, 255},
		StaticText {
			disabled,
			"Impossible de lancer ^0:\n^1."
		},
		/* [3] */
		{6, 8, 38, 40},
		Icon {
			disabled,
			500
		}
	}
};

resource 'DITL' (129, "About", preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{-1, -1, 315, 456},
		Picture {
			enabled,
			129
		},
		/* [2] */
		{9, 7, 41, 39},
		Icon {
			enabled,
			128
		}
	}
};

resource 'PICT' (128) {
	166,
	{-1, -1, 276, 272},
	$"1101 A000 82A0 008C 0100 0AFF FFFF FF01"
	$"1401 1009 FFFF FFFF FFFF FFFF 3000 0D00"
	$"0101 1301 1020 000E 0002 000E 010F 2000"
	$"0F00 0200 0F01 0E20 000F 0002 0112 0002"
	$"2000 1000 0301 1100 03A1 0096 000C 0100"
	$"0000 0200 0000 0000 0000 0100 0A00 0000"
	$"0900 0B00 FD03 0004 0D00 092B 0A09 2368"
	$"683A 6D6E 3A73 732E 6D6D 6D20 2020 502F"
	$"4320 2020 2020 2020 206D 6573 7361 6765"
	$"2020 A000 97A0 008D A000 83FF"
};

resource 'PICT' (129) {
	8248,
	{17, 43, 333, 500},
	$"0011 02FF 0C00 FFFF FFFF 002B 0000 0011"
	$"0000 01F4 0000 014D 0000 0000 0000 0001"
	$"000A 0011 002B 014D 01F4 0098 003A 0011"
	$"002B 014D 01F4 0011 002B 014D 01F4 0011"
	$"002B 014D 01F4 0000 04C8 FF00 8004 C8FF"
	$"0080 04C8 FF00 8004 C8FF 0080 04C8 FF00"
	$"8004 C8FF 0080 04C8 FF00 8004 C8FF 0080"
	$"04C8 FF00 8004 C8FF 0080 04C8 FF00 8004"
	$"C8FF 0080 04C8 FF00 8004 C8FF 0080 04C8"
	$"FF00 8009 ECFF 01FE 7FDF FF00 8011 F5FF"
	$"0480 003F FE3F FDFF 01E0 7FDF FF00 8011"
	$"F5FF 04F0 0007 FE3F FDFF 01FC 7FDF FF00"
	$"8011 F5FF 04F1 FF03 FE3F FDFF 01FC 7FDF"
	$"FF00 800F F5FF 02F1 FFE1 FBFF 01FC 7FDF"
	$"FF00 800F F5FF 02F1 FFF0 FBFF 01FC 7FDF"
	$"FF00 8010 F5FF 03F1 FFF8 7FFC FF01 FC7F"
	$"DFFF 0080 10F5 FF03 F1FF FC7F FCFF 01FC"
	$"7FDF FF00 8010 F5FF 03F1 FFFC 3FFC FF01"
	$"FC7F DFFF 0080 1DFB FF15 F9C1 F83F FC0F"
	$"F1FF FE3F BFE0 7FDE 07FC 7FC0 7E01 E03F"
	$"E4FF 0080 2BFB FF15 8180 700F F1E3 F1FF"
	$"FE3C 3F8F 1E1C 01FC 7F00 3F87 FC7F F9FF"
	$"031E 2F9B 81F9 FF03 8FCF FF3F FCFF 0080"
	$"2AFB FF14 F178 2F0F E7F3 F1FF FE30 3F3F"
	$"9813 E0FC 7E7E 1FC7 FCF8 FF03 9E7F DF75"
	$"FAFF 03FB EFEF FEFB FF00 802A FBFF 14F0"
	$"FC1F 87C7 FBF1 FFFE 3E3E 3FDF 0FF8 7C7E"
	$"FF0F C7F8 F8FF 039E 7FDF 7DFA FF03 FBEF"
	$"EFFE FBFF 0080 33FB FF14 F1FE 3FC7 C7FB"
	$"F1FF FE3E 3E3F DF1F FC3C 7FFF 8FC3 F9FA"
	$"FF17 FC3F AD6E 1BBD 30E9 9F8C 3267 4430"
	$"A8EE 7C29 9E63 4074 CF80 32FB FF14 F1FE"
	$"3FC7 C3FF F1FF FE3E 3E1F FF1F FE3C 7FFF"
	$"8FE3 F1F9 FF16 BFAD 4DD3 CCDE C56F 6BD9"
	$"9A3B BB27 6DBE C56D B66F 62B7 8033 FBFF"
	$"14F1 FE3F C7C0 FFF1 FFFE 3E3E 07FF 1FFE"
	$"3C7F FC0F E3F3 FAFF 17FE 3FAD 6BDB F5D8"
	$"EF0F 6BDB BB7A 3BAF 6C3E EF0C 36AC 7787"
	$"8033 FBFF 14F1 FE3F C7E0 0FF1 FFFE 7E3F"
	$"007F 1FFE 3C7F C38F F1F3 FAFF 17FD BFB3"
	$"6BDB F5D6 EF7F 7BDB BB79 BBAF 6DFE EF7D"
	$"F5AB 77BF 8033 FBFF 14F1 FE3F C7F0 03F1"
	$"FFFC 7E3F 801F 1FFE 3C7F 1F8F F1E7 FAFF"
	$"17FD BFB3 6B9B 75D6 EF7F 7BDB BB75 BBAE"
	$"EDFE EF7D F99B 77BF 8033 FBFF 14F1 FE3F"
	$"C7FE 01F1 FFFC 7E3F F00F 1FFE 3C7E 3F8F"
	$"F1E7 FAFF 17FC 1F1E 0441 08C0 478F 8C31"
	$"190C 1C01 C63C 478E 3BD8 23C7 8020 FBFF"
	$"14F1 FE3F C7FF E1F1 FFF8 FE3F FF0F 1FFE"
	$"7C7C 7F8F F8CF EEFF 007F F7FF 0080 20FB"
	$"FF14 F1FE 3FC7 DFF1 F1FF F9FE 3EFF 8F1F"
	$"FC7C 7C7F 8FF8 CFEE FF00 7FF7 FF00 8021"
	$"FBFF 14F1 FE3F C7DF F1F1 FFF1 FE3E FF8F"
	$"1FFC FC7C 7F8F FC4F EFFF 01FE 3FF7 FF00"
	$"801C FBFF 14F1 FE3F C7DF F3F1 FFC3 FE3E"
	$"FF9F 0FF9 FC7C 7F0F FC1F E3FF 0080 1CFB"
	$"FF14 F1FE 3FC7 CFE3 F1FF 0FFE 3E7F 1F03"
	$"E3FC 7C3C 8FFC 1FE3 FF00 801C FBFF 02F1"
	$"FE3F FEC7 0EE0 001F FE3E 3E3F 000F FC7E"
	$"038F FE3F E3FF 0080 1CFB FF14 8030 07C0"
	$"F01F C000 FFF0 0780 FF10 3FE0 0F07 83FE"
	$"3FE3 FF00 800D EEFF 001F FCFF 01FE 3FE3"
	$"FF00 800D EEFF 001F FCFF 01FE 7FE3 FF00"
	$"800D EEFF 001F FCFF 01FE 7FE3 FF00 800C"
	$"EEFF 001F FCFF 00FC E2FF 0080 0CEE FF00"
	$"1FFC FF00 FCE2 FF00 8026 EEFF 001F FCFF"
	$"00F9 FCFF 06C0 FFFF FD3F FE0F FEFF 10F1"
	$"FDFF FF9F CDFE 7FFB FFFF 3FFF 07FF FF80"
	$"33FB FF0D F07F 8307 EF8F 103F 78E3 EFFF"
	$"FF1F FCFF 0079 FCFF 00EE FEFF 02BF FDEF"
	$"FEFF 10CE FAFF FFDF EFFF 7FF5 FFFF BFFC"
	$"F7FF FF80 32FB FF0D EFBF 7BBB D7CF 3BBC"
	$"775D CFFF FF1F FCFF 0033 FCFF 00EF FEFF"
	$"01BF FBFD FF0C D17A FFFF DFEF FF7F F5FF"
	$"FFBF FBFE FF00 8033 FBFF 0DD8 DEFF BBD7"
	$"CF3B FF77 5DCF FFFF 1FFC FF00 07FC FF1A"
	$"EDF2 661D BEFB FD03 2679 AD7A F468 DCED"
	$"A767 F5E8 D1B9 FBFC 3267 8033 FBFF 0DD7"
	$"5EFF BBD7 D6BB 7F77 5DAF FFFC 03FC FF00"
	$"0FFC FF1A E1F9 9BD9 BFFB F8BB 99B6 AB77"
	$"6387 5B69 1B5F EEC7 0EB6 FBFB D99B 802C"
	$"FBFF 0AD7 DEFF A7BB D6B8 7F77 5DAF F3FF"
	$"1AED 1BBB 1DBF FBC5 E3BB B0AA F077 AF58"
	$"6DBB 3FE0 EF5E B0FB FBDB BB80 2CFB FF0A"
	$"D75E F1AF 83D6 BB7F 7861 6FF3 FF1A EFFB"
	$"BADD BFFB EDDB BBB7 A0EF B7AF 5BED BB5F"
	$"DF6F 5EB7 FBFB DBBB 802C FBFF 0AD8 DEFB"
	$"B77D D9BB FF7E FB07 F3FF 1AEE FBBA DDBF"
	$"FDED DBBB B7DF EFB7 6EDB EDBB 6FDF 6EDD"
	$"B7FD FBDB BB80 2CFB FF0A EFBF 7BBB 7DD9"
	$"BBBF 7DF7 EFF3 FF1A C0F1 1808 1EFE 18C1"
	$"1198 E0C7 10E1 8C40 1832 8E21 C318 DE04"
	$"3119 801C FBFF 0AF0 7F87 1C38 8F10 3E33"
	$"CFC7 E7FF 01F7 EFFC FF01 EFDF FCFF 0080"
	$"0ED6 FF01 F7EF FCFF 01EF DFFC FF00 800E"
	$"D6FF 01E3 C7FC FF01 C78F FCFF 0080 04C8"
	$"FF00 8002 C700 02C7 0002 C700 02C7 0002"
	$"C700 02C7 0002 C700 0AF1 0000 7FFA FF00"
	$"F8E0 000A F100 0040 FA00 0008 E000 0AF1"
	$"0000 40FA 0000 08E0 000A F100 0040 FA00"
	$"0008 E000 0AF1 0000 40FA 0000 08E0 000E"
	$"F100 005F FE00 0411 F000 0008 E000 0EF1"
	$"0000 55FE 0004 2090 0001 08E0 000E F100"
	$"0044 FE00 0420 A000 0108 E000 0EF1 0008"
	$"44DF 6607 70E6 ECDB 88E0 000E F100 0844"
	$"4999 08A0 A252 6908 E000 16F8 0000 7FFB"
	$"FF08 C451 1F08 A082 5E49 0FED FF00 80F5"
	$"0016 F800 0040 FB00 0844 5118 08A0 9190"
	$"4908 ED00 00C0 F500 16F8 0000 40FB 0008"
	$"4E21 E707 71F1 8EED 88ED 0000 C0F5 0019"
	$"F800 0040 FB00 0140 21FB 0000 08F7 0000"
	$"0FFD FFFC 0000 C0F5 0020 F800 025F BFFB"
	$"FDFF 01C0 A1FB 0000 08FA 00FE FF00 F8FE"
	$"0000 01FD FF01 FEC0 F500 23F8 0002 4020"
	$"08FD 0002 40C3 80FC 0005 080F 8C00 0180"
	$"FC00 0008 FE00 0001 FC00 00C0 F500 24F8"
	$"0002 5FA0 0BFD FF00 C0FA 0007 080C C000"
	$"0180 0000 FEFF 00F8 FE00 0001 FDFF 01FE"
	$"C0F5 0023 F800 0240 2008 FD00 0040 FA00"
	$"070B 8CCC 71F1 8F19 80FE 0004 081F 2018"
	$"01FC 0000 C0F5 0024 F800 025F A00B FDFF"
	$"00C0 FA00 070E 4CCC C999 9199 80FE FF04"
	$"F808 8408 01FD FF01 FEC0 F500 22F8 0002"
	$"4020 08FD 0000 7FF9 FF06 0CCC E199 8F99"
	$"80FE 0004 0808 8408 01FC 0000 C0F5 0022"
	$"F800 025F A00B F7FF 05C0 6667 8CCC 71FE"
	$"9900 80FE FF04 F80B 6EEB 01FD FF01 FEC0"
	$"F500 20F8 0002 4020 08F6 0004 6665 CCCC"
	$"39FE 9900 80FE 0004 0808 252D 01FC 0000"
	$"C0F5 0021 F800 025F A00B F7FF 04C0 6666"
	$"CCCC FD99 0080 FEFF 04F8 0825 0901 FDFF"
	$"01FE C0F5 0020 F800 0240 2008 F600 0866"
	$"638F 8C71 F18F 8F80 FE00 0408 0825 0901"
	$"FC00 00C0 F500 22F8 0002 5FBF FBF7 FF09"
	$"C000 0100 0001 8000 0180 FEFF 04F8 1C76"
	$"FD81 FDFF 01FE C0F5 001D F800 0040 F300"
	$"0701 0000 0180 0011 80FE 0000 08FE 0000"
	$"01FC 0000 C0F5 001A F800 0040 F300 0001"
	$"FC00 000F FD00 0008 FE00 0001 FC00 00C0"
	$"F500 16F8 0000 40F2 0000 80F8 0000 08FE"
	$"0000 01FC 0000 C0F5 0012 F800 007F E8FF"
	$"00F8 FE00 0001 FCFF 00C0 F500 16F8 0000"
	$"40F2 0000 40F8 0000 08FE 0000 01FC 0000"
	$"C0F5 0016 F800 0040 F200 0040 F800 0008"
	$"FE00 0001 FC00 00C0 F500 16F8 0000 40F2"
	$"0000 40F8 0000 08FE 0000 01FC 0000 C0F5"
	$"0014 F800 0040 F200 0020 F800 000F FDFF"
	$"FC00 00C0 F500 12F8 0000 40F2 0000 20F8"
	$"0000 08F8 0000 C0F5 0012 F800 0040 F200"
	$"0010 F800 0008 F800 00C0 F500 12F8 0000"
	$"40F2 0000 10F8 0000 10F8 0000 C0F5 0017"
	$"F800 0240 0041 F700 031E 04E0 10F8 0000"
	$"10F8 0000 C0F5 0017 F800 0240 0041 F700"
	$"0311 0510 08F8 0000 10F8 0000 C0F5 0023"
	$"F800 1040 0079 E11E 5843 CF01 E79E 0000"
	$"1109 0008 FD00 0507 8E3C F3CF 38F8 0000"
	$"C0F5 0023 F800 1040 0045 1015 6404 1001"
	$"5555 0000 1E09 0004 FD00 0505 5141 0451"
	$"64F8 0000 C0F5 0023 F800 1040 0045 1015"
	$"4403 8E01 5555 0000 1011 0004 FD00 0505"
	$"5F38 E451 7CF8 0000 C0F5 0023 F800 1040"
	$"0045 1015 4400 4101 5555 0000 1011 1004"
	$"FD00 0505 5004 14D1 40F8 0000 C0F5 0027"
	$"F800 1040 0045 1115 4447 9E11 5555 0000"
	$"1020 E002 FD00 0505 4F79 E34F 7CFD 0000"
	$"07FD FF00 FEF5 0019 F800 0040 F400 0220"
	$"0002 F900 0101 40FD 0000 04FD 0000 02F5"
	$"0017 F800 0040 F200 0001 F900 010E 80FD"
	$"0000 04FD 0000 02F5 0016 F800 0040 F200"
	$"0001 F800 0080 FD00 0004 FD00 0002 F500"
	$"17F8 0000 40F2 0000 01F8 0000 80FD 0005"
	$"05DC 1800 8002 F500 0FF8 0000 40E3 FF05"
	$"FC88 0800 1002 F500 0FF8 0000 40E3 FF05"
	$"FC88 0800 1002 F500 0FF8 0000 40E3 FF05"
	$"FC89 89CF BEE2 F500 18F8 0001 40E0 F200"
	$"0040 FA00 0002 FC00 0504 524A 3292 42F5"
	$"0018 F800 0140 E0F2 0000 50FA 0000 02FC"
	$"0005 0453 CA30 9282 F500 18F8 0001 40E0"
	$"F200 00B8 FA00 0002 FC00 0504 220A 3092"
	$"82F5 0018 F800 0140 E0F2 0000 78FA 0000"
	$"04FC 0005 0421 DDCF D902 F500 18F8 0001"
	$"40E0 F200 0038 FA00 0004 FC00 0004 FE00"
	$"0101 02F5 0028 F800 1940 E038 E00E 0803"
	$"8E01 F09F 0000 1104 2000 19E0 0000 E400"
	$"0823 84FC 0000 04FE 0001 0502 F500 28F8"
	$"0019 40E0 4510 1118 0450 0011 9000 001B"
	$"0460 0009 1000 0114 0010 644A FC00 0004"
	$"FE00 0106 02F5 0027 F800 1940 E045 1101"
	$"0840 5E00 129E 0000 1508 2000 0115 8E3D"
	$"0780 20A4 49FC 0000 04FD 0000 02F5 0027"
	$"F800 1940 E045 1006 0801 9100 2481 0000"
	$"1108 2000 01E6 5145 0440 2124 49FC 0000"
	$"04FD 0000 02F5 0027 F800 1940 E045 1001"
	$"0800 5100 47C1 0000 1110 2000 0104 1145"
	$"0440 21F3 D1FC 0000 07FD FF00 FEF5 0028"
	$"F800 1940 E045 1011 0804 5100 4091 0000"
	$"1110 2000 0104 1145 1440 1020 52FC 0005"
	$"1800 0002 00C0 F500 28F8 0019 40E0 38E1"
	$"0E08 438E 1040 8E00 0011 2020 0001 040E"
	$"3CE4 4008 2394 FC00 0560 0000 0200 C0F5"
	$"001D F800 0140 E0F5 0000 20FC 0000 04FD"
	$"0000 20FD 0006 0180 0000 0200 C0F5 0019"
	$"F800 0140 E0EF 0000 38FD 0000 20FD 0000"
	$"06FE 0002 0200 C0F5 0015 F800 0140 E0EA"
	$"0000 20FD 0000 18FE 0002 0200 C0F5 0015"
	$"F800 0140 E0EA 0000 40FD 0000 60FE 0002"
	$"0200 C0F5 0017 F800 0140 E0EB 0001 0440"
	$"FE00 0101 80FE 0002 0200 C0F5 0029 F800"
	$"1D40 E038 E00E 0800 8200 27CE 0000 1104"
	$"2000 00E1 0010 E400 09F4 4208 4000 0EFD"
	$"0002 0200 C0F5 0029 F800 1D40 E045 1011"
	$"1801 8600 6411 0000 1B04 6000 0111 0011"
	$"1400 1014 8618 2000 30FD 0002 0200 C0F5"
	$"0028 FE00 F8FF 1AF1 0108 4282 0027 8100"
	$"0015 0820 0001 0396 1107 8020 1682 0810"
	$"00C0 FD00 0202 00C0 F500 29FE 0000 80F9"
	$"0019 1006 0804 8200 2042 0000 1108 2000"
	$"0101 1911 0440 2026 8208 1083 FC00 0202"
	$"00C0 F500 29FE 0000 80F9 0019 1001 0807"
	$"C200 2044 0000 1110 2000 0101 1011 0440"
	$"2043 2208 110C FC00 0202 00C0 F500 29FE"
	$"0000 80F9 0019 1011 0800 8200 2448 0000"
	$"1110 2000 0111 1011 1440 1043 4208 2330"
	$"FC00 0202 00C0 F500 29FE 0000 80F9 0019"
	$"110E 0840 8210 239F 0000 1120 2000 00E0"
	$"D010 E440 0843 8208 46C0 FC00 0202 00C0"
	$"F500 21FE 0009 83E0 0000 0400 00C0 0010"
	$"F700 0020 F800 0403 0000 0F80 FC00 0202"
	$"00C0 F500 1DFE 0009 8110 0000 2000 0040"
	$"4010 ED00 0403 0000 1FF0 FC00 0202 00C0"
	$"F500 1DFE 0009 8110 0000 2000 0040 4010"
	$"ED00 0402 0000 3F80 FC00 0202 00C0 F500"
	$"15FE 0009 81E3 1D9B 7CED 83DE EC10 E300"
	$"0202 00C0 F500 15FE 0009 8144 A64C A516"
	$"8442 5210 E300 0202 00C0 F500 30FE 0019"
	$"8127 A3C8 A514 844E 5E10 0E08 008E 00E3"
	$"8E00 0011 0420 0001 1004 FE00 0D08 E7C0"
	$"08E7 C008 E384 0000 0200 C0F5 0030 FE00"
	$"1981 1422 08A5 1484 D250 1011 1801 9001"
	$"1451 0000 1B04 6000 0190 04FE 000D 1114"
	$"0019 1040 1914 4200 0002 00C0 F500 30FE"
	$"002A 838B 9DCF 3EEE C37F 6E11 0108 429E"
	$"0110 5100 0015 0820 0001 538E 3800 0020"
	$"1780 0810 4009 1441 0000 0200 C0F5 002E"
	$"FE00 0380 0000 08FC 0021 1006 0804 9101"
	$"118E 0000 1108 2000 0134 4444 0000 2020"
	$"4008 2080 0914 4100 0002 00C0 F500 2EFE"
	$"0003 8000 0008 FC00 2110 0108 07D1 0110"
	$"5100 0011 1020 0001 1444 7C00 0020 4040"
	$"0841 0009 1441 0000 0200 C0F5 002E FE00"
	$"0380 0000 1CFC 0021 1011 0800 9101 1451"
	$"0000 1110 2000 0114 4440 0000 1084 4008"
	$"8100 0914 4200 0002 00C0 F500 2BFE 0000"
	$"80F9 0021 110E 0840 8E10 E38E 0000 1120"
	$"2000 0113 833C 0000 09F3 8009 F100 08E3"
	$"8400 0002 00C0 F500 14FE 0000 80F9 0000"
	$"10F7 0000 20EE 0002 0200 C0F5 0010 FE00"
	$"0080 F900 0010 E300 0202 00C0 F500 0CFE"
	$"00F8 FF00 F0E7 0000 0CEF 000A F500 0010"
	$"E700 0007 EF00 0BF5 0000 08E7 0001 07E0"
	$"F000 0BF5 0000 04E7 0001 0698 F000 0BF5"
	$"0000 02E7 0001 0240 F000 0BF5 0000 01E7"
	$"0001 0220 F000 0BF4 0000 82E8 0001 0110"
	$"F000 0BF4 0000 40E8 0001 0108 F000 0AF4"
	$"0000 21E7 0000 04F0 000A F400 0011 E700"
	$"0002 F000 0BF4 0001 0880 E800 0001 F000"
	$"0BF4 0001 04C0 E700 0080 F100 0BF4 0001"
	$"3BC0 E700 0040 F100 0BF4 0001 0FE0 E700"
	$"0020 F100 0BF4 0001 03E0 E700 0010 F100"
	$"0AF3 0000 70E7 0000 08F1 0013 F800 0140"
	$"E0FE 0000 10E7 0004 0400 0200 C0F5 000F"
	$"F800 0140 E0E3 0004 0200 0200 C0F5 002A"
	$"F800 1C40 E038 E00E 7C03 8200 E08E 0000"
	$"1104 2000 01F0 0010 0000 2910 0410 0280"
	$"FE00 0401 0002 00C0 F500 29F8 001C 40E0"
	$"4510 1140 0446 0111 9100 001B 0460 0000"
	$"4000 1000 0029 1004 1002 80FD 0003 8002"
	$"00C0 F500 28F8 001B 40E0 4511 0178 4042"
	$"0010 9100 0015 0820 0000 4391 3800 0001"
	$"1384 10E0 FC00 0340 0200 C0F5 0028 F800"
	$"1B40 E045 1006 0400 8200 2091 0000 1108"
	$"2000 0044 4A10 0000 01F4 4411 10FC 0003"
	$"2002 00C0 F500 28F8 001B 40E0 4510 0104"
	$"0102 0040 9100 0011 1020 0000 47C4 1000"
	$"0001 17C4 1110 FC00 0310 0200 C0F5 0028"
	$"F800 1B40 E045 1011 4402 0200 8091 0000"
	$"1110 2000 0044 0A10 0000 0114 0411 10FC"
	$"0003 0802 00C0 F500 29F8 001B 40E0 38E1"
	$"0E38 47C2 11F0 8E00 0011 2020 0000 43D1"
	$"0C00 0001 13C4 10E0 FC00 000F F9FF 00C0"
	$"FB00 13F8 0001 40E0 F500 0020 EF00 0008"
	$"F900 0040 FB00 0FF8 0001 40E0 E200 0008"
	$"F900 0040 FB00 0FF8 0001 40E0 E200 0008"
	$"F900 0040 FB00 0FF8 0001 40E0 E200 0008"
	$"F900 0040 FB00 14F8 0001 40E0 E200 0908"
	$"F800 0010 0004 0010 40FB 002F F800 1340"
	$"E038 E00E 7C03 8200 E08E 0000 1104 2000"
	$"0027 04FE 0005 2910 0000 010A FD00 0908"
	$"4400 0080 0004 0010 40FB 002F F800 1340"
	$"E045 1011 4004 4601 1191 0000 1B04 6000"
	$"0040 82FE 0005 29B0 0000 010A FD00 0908"
	$"4200 0080 0008 0008 40FB 002F F800 1340"
	$"E045 1101 7840 4200 1091 0000 1508 2000"
	$"0083 41FE 0005 0153 9F3D 6380 FD00 0908"
	$"42DB FDF3 B60B 6CE8 40FB 002E F800 1340"
	$"E045 1006 0400 8200 2091 0000 1108 2000"
	$"0084 41FE 0004 0114 4245 91FC 0009 0842"
	$"4904 945A 09B5 0840 FB00 2EF8 0013 40E0"
	$"4510 0104 0102 0040 9100 0011 1020 0000"
	$"8341 FE00 0401 1444 4501 FC00 0908 4249"
	$"1C94 5209 2488 40FB 002E F800 1340 E045"
	$"1011 4402 0200 8091 0000 1110 2000 0040"
	$"82FE 0004 0114 484D 01FC 0009 0844 4924"
	$"9452 0924 6840 FB00 2FF8 0013 40E0 38E1"
	$"0E38 47C2 11F0 8E00 0011 2020 0000 2704"
	$"FE00 0501 139F 3500 C0FD 0009 08F8 3FBE"
	$"FBBB 0BB7 C840 FB00 16F8 0001 40E0 F500"
	$"0020 EF00 0008 FC00 0304 0010 40FB 0012"
	$"F800 0140 E0E2 0000 08FC 0003 0400 1040"
	$"FB00 0FF8 0001 40E0 E200 0008 F900 0040"
	$"FB00 0FF8 0001 40E0 E200 0008 F900 0040"
	$"FB00 0FF8 0001 40E0 E200 0008 F900 0040"
	$"FB00 2BF8 0013 40E0 38E0 0E7C 0382 00E0"
	$"8E00 0011 0420 0000 E011 FE00 0128 E0FE"
	$"0005 0400 A000 0008 F900 0040 FB00 2BF8"
	$"0013 40E0 4510 1140 0446 0111 9100 001B"
	$"0460 0001 1019 FE00 0129 10FE 0005 0400"
	$"A000 000F F9FF 00C0 FB00 29F8 001D 40E0"
	$"4511 0178 4042 0010 9100 0015 0820 0001"
	$"03D5 3DE3 8001 0396 38E5 8E38 FD00 0202"
	$"00C0 F500 29F8 001D 40E0 4510 0604 0082"
	$"0020 9100 0011 0820 0000 E453 4554 4001"
	$"0459 4516 4444 FD00 0202 00C0 F500 29F8"
	$"001D 40E0 4510 0104 0102 0040 9100 0011"
	$"1020 0000 1451 4557 C001 0451 41F4 0444"
	$"FD00 0202 00C0 F500 29F8 001D 40E0 4510"
	$"1144 0202 0080 9100 0011 1020 0001 1451"
	$"4D54 0001 1451 4104 0444 FD00 0202 00C0"
	$"F500 29F8 001D 40E0 38E1 0E38 47C2 11F0"
	$"8E00 0011 2020 0000 E3D1 3553 C000 E391"
	$"3CF4 0338 FD00 0202 00C0 F500 15F8 0001"
	$"40E0 F500 0020 FD00 0040 F300 0202 00C0"
	$"F500 11F8 0001 40E0 F000 0040 F300 0202"
	$"00C0 F500 0DF8 0001 40E0 E100 0202 00C0"
	$"F500 0DF8 0001 40E0 E100 0202 00C0 F500"
	$"0DF8 0001 40E0 E100 0202 00C0 F500 28F8"
	$"001C 40E0 38E0 0E7C 0382 00E0 8E00 0011"
	$"0420 0000 4000 1000 0029 E100 0002 80FC"
	$"0002 0200 C0F5 0028 F800 1C40 E045 1011"
	$"4004 4601 1191 0000 1B04 6000 0040 0010"
	$"0000 2910 0000 0280 FC00 0202 00C0 F500"
	$"27F8 001B 40E0 4511 0178 4042 0010 9100"
	$"0015 0820 0000 458F 3960 0001 110F 58E0"
	$"FB00 0202 00C0 F500 27F8 001B 40E0 4510"
	$"0604 0082 0020 9100 0011 0820 0000 4650"
	$"1190 0001 E111 6510 FB00 0202 00C0 F500"
	$"27F8 001B 40E0 4510 0104 0102 0040 9100"
	$"0011 1020 0000 444E 1100 0001 0111 4510"
	$"FB00 0202 00C0 F500 27F8 001B 40E0 4510"
	$"1144 0202 0080 9100 0011 1020 0000 4441"
	$"1100 0001 0113 4510 FB00 0202 00C0 F500"
	$"27F8 001B 40E0 38E1 0E38 47C2 11F0 8E00"
	$"0011 2020 0000 445E 0D00 0001 010D 44E0"
	$"FB00 0202 00C0 F500 11F8 0001 40E0 F500"
	$"0020 EE00 0202 00C0 F500 0DF8 0001 40E0"
	$"E100 0202 00C0 F500 0DF8 0001 40E0 E100"
	$"0202 00C0 F500 0DF8 0001 40E0 E100 0202"
	$"00C0 F500 0DF8 0001 40E0 E100 0202 00C0"
	$"F500 28F8 001C 40E0 38E0 0E7C 0382 00E0"
	$"8E00 0011 0420 0001 1000 4000 0028 0000"
	$"4000 8AFC 0002 0200 C0F5 0028 F800 1C40"
	$"E045 1011 4004 4601 1191 0000 1B04 6000"
	$"01B0 0040 0000 2800 0040 018A FC00 0202"
	$"00C0 F500 28F8 001C 40E0 4511 0178 4042"
	$"0010 9100 0015 0820 0001 53D6 48E5 8001"
	$"E3D6 4800 80FC 0002 0200 C0F5 0028 F800"
	$"1C40 E045 1006 0400 8200 2091 0000 1108"
	$"2000 0114 5951 1640 0154 5950 0080 FC00"
	$"0202 00C0 F500 28F8 001C 40E0 4510 0104"
	$"0102 0040 9100 0011 1020 0001 1450 71F4"
	$"0001 5450 7000 80FC 0002 0200 C0F5 0028"
	$"F800 1C40 E045 1011 4402 0200 8091 0000"
	$"1110 2000 0114 D049 0400 0154 D048 0080"
	$"FC00 0202 00C0 F500 28F8 001C 40E0 38E1"
	$"0E38 47C2 11F0 8E00 0011 2020 0001 1350"
	$"44F4 0001 5350 4400 80FC 0002 0200 C0F5"
	$"0011 F800 0140 E0F5 0000 20EE 0002 0200"
	$"C0F5 000D F800 0140 E0E1 0002 0200 C0F5"
	$"000D F800 0140 E0E1 0002 0200 C0F5 000D"
	$"F800 0140 E0E1 0002 0200 C0F5 000D F800"
	$"0140 E0E1 0002 0200 C0F5 002A F800 2440"
	$"E038 E00E 7C03 8200 E08E 0000 1104 2000"
	$"00E0 0078 4000 29E0 0000 0400 4000 0028"
	$"0002 00C0 F500 2AF8 0024 40E0 4510 1140"
	$"0446 0111 9100 001B 0460 0001 1000 4440"
	$"0029 1000 0004 0040 0000 2800 0200 C0F5"
	$"002A F800 2440 E045 1101 7840 4200 1091"
	$"0000 1508 2000 0104 4E44 E000 0113 9139"
	$"6780 78E5 8E00 0002 00C0 F500 2AF8 0024"
	$"40E0 4510 0604 0082 0020 9100 0011 0820"
	$"0001 0451 7840 0001 E451 4594 4045 1651"
	$"0000 0200 C0F5 002A F800 2440 E045 1001"
	$"0401 0200 4091 0000 1110 2000 0104 5F40"
	$"4000 0117 D17D 0440 45F4 1F00 0002 00C0"
	$"F500 2AF8 0024 40E0 4510 1144 0202 0080"
	$"9100 0011 1020 0001 14D0 4040 0001 140A"
	$"4104 4045 0410 0000 0200 C0F5 002A F800"
	$"2440 E038 E10E 3847 C211 F08E 0000 1120"
	$"2000 00E3 4F40 3000 0113 C43D 0780 44F4"
	$"0F00 0002 00C0 F500 11F8 0001 40E0 F500"
	$"0020 EE00 0202 00C0 F500 0DF8 0001 40E0"
	$"E100 0202 00C0 F500 0DF8 0001 40E0 E100"
	$"0202 00C0 F500 0DF8 0001 40E0 E100 0202"
	$"00C0 F500 0DF8 0001 40E0 E100 0202 00C0"
	$"F500 2AF8 0024 40E0 38E0 0E7C 038E 0023"
	$"8200 0011 0420 0000 E45E 7DF0 0008 2002"
	$"3803 8201 F380 0801 0200 C0F5 002A F800"
	$"2440 E045 1011 4004 5100 6446 0000 1B04"
	$"6000 0116 D111 0000 1060 0644 0446 0104"
	$"4018 0082 00C0 F500 2AF8 0024 40E0 4511"
	$"0178 4041 0024 4A00 0015 0820 0001 0551"
	$"1100 0020 2002 4400 4A01 E440 0800 4200"
	$"C0F5 002A F800 2440 E045 1006 0400 8600"
	$"2392 0000 1108 2000 00E4 5E11 E000 2020"
	$"0244 0092 0014 4008 0042 00C0 F500 2AF8"
	$"0024 40E0 4510 0104 0101 0024 5F00 0011"
	$"1020 0000 1450 1100 0020 2002 4401 1F00"
	$"13C0 0800 4200 C0F5 002A F800 2440 E045"
	$"1011 4402 1100 2442 0000 1110 2000 0114"
	$"5011 0000 1020 0244 0202 0110 4008 0082"
	$"00C0 F500 2AF8 0024 40E0 38E1 0E38 47CE"
	$"1023 8200 0011 2020 0000 E450 11F0 0008"
	$"2002 3807 C200 E380 0951 0200 C0F5 0011"
	$"F800 0140 E0F5 0000 20EE 0002 0200 C0F5"
	$"000D F800 0140 E0E1 0002 0200 C0F5 0011"
	$"F800 0140 E0F4 0000 0CEF 0002 0200 C0F5"
	$"0013 F800 0140 E0F6 0002 4000 07EF 0002"
	$"0200 C0F5 0015 F800 0140 E0F7 0004 01C0"
	$"0007 E0F0 0002 0200 C0F5 0015 F800 0140"
	$"E0F7 0004 0F80 0007 18F0 0002 0200 C0F5"
	$"0015 F800 0140 E0F7 0004 3D80 0002 80F0"
	$"0002 0200 C0F5 0015 F800 0140 E0F7 0004"
	$"0900 0002 40F0 0002 0200 C0F5 0015 F800"
	$"0140 E0F7 0004 1200 0001 20F0 0002 0200"
	$"C0F5 0015 F800 0140 E0F7 0004 2200 0001"
	$"10F0 0002 0200 C0F5 0015 F800 0140 E0F7"
	$"0000 40FE 0000 08F0 0002 0200 C0F5 000C"
	$"F800 0040 E0FF 02FE 00C0 F500 12F8 0000"
	$"40F7 0000 01FD 0000 02EE 0000 C0F5 0012"
	$"F800 0040 F700 0002 FD00 0001 EE00 00C0"
	$"F500 12F8 0000 40F7 0000 04FC 0000 80EF"
	$"0000 C0F5 0012 F800 0040 F700 0008 FC00"
	$"0040 EF00 00C0 F500 1AF8 0000 40FB 0000"
	$"1FFE FF00 F8FD 0000 1FFC FF00 E0F4 0000"
	$"C0F5 001A F800 0040 FB00 0010 FE00 0008"
	$"FD00 0010 FC00 0020 F400 00C0 F500 1AF8"
	$"0000 40FB 0000 10FE 0000 08FD 0000 10FC"
	$"0000 20F4 0000 C0F5 001A F800 0040 FB00"
	$"0010 FE00 0008 FD00 0010 FC00 0020 F400"
	$"00C0 F500 1CF8 0000 7FFB FF04 F03E 0000"
	$"0FFD FF06 103D 8000 0018 3FF4 FF00 C0F5"
	$"0014 F100 0410 1100 2008 FD00 0610 4480"
	$"0000 0820 E700 14F1 0004 1011 0020 08FD"
	$"0006 1080 8000 0008 20E7 0014 F100 0410"
	$"1677 F008 FD00 0610 80B7 B6D9 8820 E700"
	$"14F1 0004 1010 8A20 08FD 0006 1080 D09A"
	$"6A48 20E7 0014 F100 0410 108A 2008 FD00"
	$"0610 8093 924B C820 E700 14F1 0004 1010"
	$"8A20 08FD 0006 1040 9492 4A08 20E7 0014"
	$"F100 0410 3877 3008 FD00 0610 3DDF FBED"
	$"DC20 E700 12F1 0000 10FE 0000 08FD 0000"
	$"10FC 0000 20E7 0012 F100 0010 FE00 0008"
	$"FD00 0010 FC00 0020 E700 12F1 0000 10FE"
	$"0000 08FD 0000 10FC 0000 20E7 0012 F100"
	$"001F FEFF 00F8 FD00 0010 FC00 0020 E700"
	$"0AE8 0000 10FC 0000 20E7 000A E800 001F"
	$"FCFF 00E0 E700 02C7 0002 C700 02C7 0002"
	$"C700 04C8 FF00 8002 C700 04C8 FF00 8002"
	$"C700 02C7 0002 C700 02C7 0002 C700 02C7"
	$"0002 C700 2AFD 0010 3F10 0060 0000 C800"
	$"3000 0003 0001 C3A0 C8FA 0009 0200 0060"
	$"6000 0002 0004 F700 0306 4000 10FB 002D"
	$"FD00 1010 8000 2000 0040 0010 0000 1100"
	$"00C3 0040 FE00 0008 FB00 0120 80FE 0000"
	$"40FE 0000 04FA 0002 0200 01FA 002D FD00"
	$"1010 4000 2000 0040 0010 0000 1100 00C3"
	$"0040 FE00 0008 FB00 0120 80FE 0000 40FE"
	$"0000 04FA 0002 0200 01FA 0039 3500 006C"
	$"C710 5397 2F3B 83C9 CB97 9DDC 3D61 80A5"
	$"23C8 19DC C59E E0B3 1C62 EE61 E1EB 79B3"
	$"02F7 04B1 722F 0E78 896E 3078 B972 4EF3"
	$"D3C5 8EFD 0039 3500 0033 2910 74B8 A111"
	$"045A 5C50 88A4 1192 40A5 6458 2489 2E49"
	$"21D4 A496 4492 209D 84CC 8649 0DCB 8E64"
	$"1285 9BB2 4809 C78A D211 342E 52FD 0039"
	$"3500 0022 2C10 5610 A712 084B 0853 8930"
	$"1113 C0A5 2848 3C89 E449 8087 A4F2 44F4"
	$"2088 8488 824C 0489 0A24 1884 8912 7838"
	$"850A 5271 1424 58FD 0039 3500 0022 2310"
	$"5190 A90A 0848 C854 850C 1112 0099 2848"
	$"2051 0448 6084 2082 2884 2088 8488 8243"
	$"0489 0A24 0684 8910 4048 850A 5091 1424"
	$"46FD 0039 3500 0022 2910 9491 290C 08CA"
	$"4894 8624 1112 0099 28C8 2051 0449 2084"
	$"2082 2884 6088 8488 8249 0489 1264 1284"
	$"9910 4048 8912 5091 1424 52FD 0039 3500"
	$"0077 3E3F 3F1E 7F8C 077F 8F3F C638 0F99"
	$"C1C3 F77C 1C20 EE67 C1C3 9C77 1073 B1DC"
	$"79DC C73E 0FCD E1B3 1C78 6F8E 387C F1E7"
	$"EEF8 FBCE 7CFD 0015 FB00 0710 0008 0000"
	$"0800 04E9 0000 01F9 0000 81F7 0015 FB00"
	$"0710 0028 0000 0800 14E9 0000 01F9 0000"
	$"81F7 0018 FB00 0738 0030 0000 1C00 18E9"
	$"0001 0380 FB00 0201 C380 F800 02C7 0002"
	$"C700 02C7 0002 C700 02C7 0000 00FF"
};

resource 'ICON' (500) {
	$"FFFF FFFF 8000 0001 8003 0001 8005 F001"
	$"801F 8F31 8363 80D9 8580 4379 8780 2C31"
	$"8300 30C1 8080 CD01 805B 1601 802C 1E01"
	$"803C 0C01 8018 0001 8000 0001 FFFF FFFF"
	$"B9C4 739D B9C4 739D B9C4 739D B9C4 739D"
	$"B9C4 739D B9C4 739D B9C4 739D B9C4 739D"
	$"9084 2109 9084 2109 9084 2109 9084 2109"
	$"9084 2109 9084 2109 9084 2109 FFFF FFFF"
};

resource 'ICON' (128) {
	$"FFFF FFFF 9000 0001 9000 0001 FFFF FFFF"
	$"8000 0001 BFFF FFFD A000 0005 A5E7 CFE5"
	$"A000 0005 A6E6 4FA5 A000 0005 A765 CDE5"
	$"A000 0005 A6E5 CFA5 A000 0005 A7E5 4DE5"
	$"A000 0005 A7A6 CEE5 A000 0005 A6E7 CF65"
	$"A000 0005 A000 0005 A000 0005 A000 0005"
	$"A000 0005 A000 0005 A000 0005 A000 0005"
	$"A000 0005 BFFF FFFD 8000 0001 FFFF FFFF"
};

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	65536,
	65536
};

resource 'SIZE' (1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	131072,
	131072
};

resource 'SIZE' (0) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	131072,
	65536
};

resource 'BNDL' (128, purgeable) {
	'Disp',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		}
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	"Disp"
};

resource 'ICN#' (128, "display") {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 9000 0001 9000 0001 FFFF FFFF"
		$"8000 0001 BFFF FFFD A000 0005 A5E7 CFE5"
		$"A000 0005 A6E6 4FA5 A000 0005 A765 CDE5"
		$"A000 0005 A6E5 CFA5 A000 0005 A7E5 4DE5"
		$"A000 0005 A7A6 CEE5 A000 0005 A6E7 CF65"
		$"A000 0005 A000 0005 A000 0005 A000 0005"
		$"A000 0005 A000 0005 A000 0005 A000 0005"
		$"A000 0005 BFFF FFFD 8000 0001 FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'vers' (2) {
	0x1,
	0x50,
	release,
	0x0,
	verFrance,
	"1.50",
	" 1987-92 GRAME"
};

data 'Disp' (0) {
	$"0B56 6572 7369 6F6E 2031 2E35"                      /* .Version 1.5 */
};

resource 'ALRT' (500, "Errors") {
	{100, 100, 183, 361},
	500,
	{	/* array: 4 elements */
		/* [1] */
		OK, invisible, silent,
		/* [2] */
		OK, invisible, silent,
		/* [3] */
		OK, invisible, silent,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'STR#' (500, "Errors") {
	{	/* array StringArray: 2 elements */
		/* [1] */
		"MidiShare non implant",
		/* [2] */
		"trop d'applications MidiShare"
	}
};

resource 'icl8' (128) {
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFB FBFB 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2BFD"
	$"FDFB FBFB 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2BFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FD7F 7F7F 7F7F 7F7F 7F7F 7F7F 7F7F 7F7F"
	$"7F7F 7F7F 7F7F 7F7F 7F7F 7F7F 7F7F 7FFD"
	$"FD7F 5454 5454 5454 5454 5454 5454 5454"
	$"5454 5454 5454 5454 5454 5454 5400 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2BFF 2BFF FFFF FF2B 2BFF FFFF"
	$"FFFF 2B2B FFFF FFFF FFFF FF2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2BFF FF2B FFFF FF2B 2BFF FF2B"
	$"2BFF 2B2B FFFF FFFF FF2B FF2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2BFF FFFF 2BFF FF2B 2BFF 2BFF"
	$"FFFF 2B2B FFFF 2BFF FFFF FF2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2BFF FF2B FFFF FF2B 2BFF 2BFF"
	$"FFFF 2B2B FFFF FFFF FF2B FF2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2BFF FFFF FFFF FF2B 2BFF 2BFF"
	$"2BFF 2B2B FFFF 2BFF FFFF FF2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2BFF FFFF FF2B FF2B 2BFF FF2B"
	$"FFFF 2B2B FFFF FF2B FFFF FF2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2BFF FF2B FFFF FF2B 2BFF FFFF"
	$"FFFF 2B2B FFFF FFFF 2BFF FF2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B2B 2B2B"
	$"2B2B 2B2B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 5400 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 2AFD"
	$"FD7F 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A"
	$"2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2AFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
};

resource 'ics#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF 8001 FFFF 8001 BFFD A005 AF75 A005"
		$"AED5 A005 AF75 A005 A005 BFFD 8001 FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ics8' (128) {
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDF8 F8F8 F8F8 F8F8 F8F8 F8F8 F8F8 F8FD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FD7F 7F7F 7F7F 7F7F 7F7F 7F7F 7F7F 7FFD"
	$"FD7F 5454 5454 5454 5454 5454 5454 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B FFFF FFFF 2BFF FFFF 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B FFFF FF2B FFFF 2BFF 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B FFFF FFFF 2BFF FFFF 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 542B 2B2B 2B2B 2B2B 2B2B 2B00 2AFD"
	$"FD7F 5400 0000 0000 0000 0000 0000 2AFD"
	$"FD7F 2A2A 2A2A 2A2A 2A2A 2A2A 2A2A 2AFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
};

resource 'ics4' (128) {
	$"FFFF FFFF FFFF FFFF FCCC CCCC CCCC CCCF"
	$"FFFF FFFF FFFF FFFF FDDD DDDD DDDD DDDF"
	$"FDCC CCCC CCCC CCCF FDCC CCCC CCCC C0CF"
	$"FDCC FFFF CFFF C0CF FDCC CCCC CCCC C0CF"
	$"FDCC FFFC FFCF C0CF FDCC CCCC CCCC C0CF"
	$"FDCC FFFF CFFF C0CF FDCC CCCC CCCC C0CF"
	$"FDCC CCCC CCCC C0CF FDC0 0000 0000 00CF"
	$"FDCC CCCC CCCC CCCF FFFF FFFF FFFF FFFF"
};

resource 'icl4' (128) {
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FEEE CCCC CCCC CCCC CCCC CCCC CCCC CCCF"
	$"FEEE CCCC CCCC CCCC CCCC CCCC CCCC CCCF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	$"FDDD DDDD DDDD DDDD DDDD DDDD DDDD DDDF"
	$"FDDD DDDD DDDD DDDD DDDD DDDD DDDD DDCF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CFCF FFFC CFFF FFCC FFFF FFFC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CFFC FFFC CFFC CFCC FFFF FCFC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CFFF CFFC CFCF FFCC FFCF FFFC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CFFC FFFC CFCF FFCC FFFF FCFC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CFFF FFFC CFCF CFCC FFCF FFFC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CFFF FCFC CFFC FFCC FFFC FFFC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CFFC FFFC CFFF FFCC FFFF CFFC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDDC CCCC CCCC CCCC CCCC CCCC CCCC C0CF"
	$"FDD0 0000 0000 0000 0000 0000 0000 00CF"
	$"FDCC CCCC CCCC CCCC CCCC CCCC CCCC CCCF"
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
};

data 'cicn' (128) {
	$"0000 0000 8010 0000 0000 0020 0020 0000"            /* .......... . .. */
	$"0000 0000 0000 0048 0000 0048 0000 0000"            /* .......H...H.... */
	$"0004 0001 0004 0000 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 0004 0000 0000 0020 0020"            /* ............. .  */
	$"0000 0000 0004 0000 0000 0020 0020 0000"            /* ........... . .. */
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF 9000 0001 9000 0001 FFFF"            /* .............. */
	$"FFFF 8000 0001 BFFF FFFD A000 0005 A5E7"            /* ............ */
	$"CFE5 A000 0005 A6E6 4FA5 A000 0005 A765"            /* .....O...e */
	$"CDE5 A000 0005 A6E5 CFA5 A000 0005 A7E5"            /* .....ϥ.... */
	$"4DE5 A000 0005 A7A6 CEE5 A000 0005 A6E7"            /* M......... */
	$"CF65 A000 0005 A000 0005 A000 0005 A000"            /* e.......... */
	$"0005 A000 0005 A000 0005 A000 0005 A000"            /* ............ */
	$"0005 A000 0005 BFFF FFFD 8000 0001 FFFF"            /* ............. */
	$"FFFF 0000 0000 0000 0007 0000 FFFF FFFF"            /* ................ */
	$"FFFF 0001 CCCC CCCC FFFF 0002 9999 9999"            /* ........ */
	$"FFFF 0003 6666 6666 CCCC 0004 CCCC CCCC"            /* ....ffff.. */
	$"CCCC 0005 5555 5555 5555 0006 2222 2222"            /* ..UUUUUU.."""" */
	$"2222 000F 0000 0000 0000 6666 6666 6666"            /* ""........ffffff */
	$"6666 6666 6666 6666 6666 6555 4444 4444"            /* ffffffffffeUDDDD */
	$"4444 4444 4444 4444 4446 6555 4444 4444"            /* DDDDDDDDDFeUDDDD */
	$"4444 4444 4444 4444 4446 6666 6666 6666"            /* DDDDDDDDDFffffff */
	$"6666 6666 6666 6666 6666 6333 3333 3333"            /* ffffffffffc33333 */
	$"3333 3333 3333 3333 3336 6322 2222 2222"            /* 3333333336c""""" */
	$"2222 2222 2222 2222 2016 6324 4444 4444"            /* """""""" .c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4F4F FFF4"            /* DDDDDDDD@.c$OO.. */
	$"4FFF FF44 FFFF FFF4 4016 6324 4444 4444"            /* O..D....@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4FF4 FFF4"            /* DDDDDDDD@.c$O... */
	$"4FF4 4F44 FFFF F4F4 4016 6324 4444 4444"            /* O.OD....@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4FFF 4FF4"            /* DDDDDDDD@.c$O.O. */
	$"4F4F FF44 FF4F FFF4 4016 6324 4444 4444"            /* OO.D.O..@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4FF4 FFF4"            /* DDDDDDDD@.c$O... */
	$"4F4F FF44 FFFF F4F4 4016 6324 4444 4444"            /* OO.D....@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4FFF FFF4"            /* DDDDDDDD@.c$O... */
	$"4F4F 4F44 FF4F FFF4 4016 6324 4444 4444"            /* OOOD.O..@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4FFF F4F4"            /* DDDDDDDD@.c$O... */
	$"4FF4 FF44 FFF4 FFF4 4016 6324 4444 4444"            /* O..D....@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4FF4 FFF4"            /* DDDDDDDD@.c$O... */
	$"4FFF FF44 FFFF 4FF4 4016 6324 4444 4444"            /* O..D..O.@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6324 4444 4444"            /* DDDDDDDD@.c$DDDD */
	$"4444 4444 4444 4444 4016 6320 0000 0000"            /* DDDDDDDD@.c .... */
	$"0000 0000 0000 0000 0016 6311 1111 1111"            /* ..........c..... */
	$"1111 1111 1111 1111 1116 6666 6666 6666"            /* ..........ffffff */
	$"6666 6666 6666 6666 6666"                           /* ffffffffff */
};

