{}
{                                  ECHO                                        }
{------------------------------------------------------------------------------} 
{ 																				}
{ Le programme ECHO prsent ici, fait partie d'une srie d'exemples  		}
{ caractre pdagogique (enfin j'espre !) sur la faon d'utiliser MIDISHARE.	}
{ 																				}
{ Comme son nom l'indique, ECHO effectue un cho temps-rel sur les notes		}
{ reues. Il dispose de quatre types de controles :							}
{       - Le delai entre les chos successifs (en millisecondes)               }
{       - La variation de vlocit entre les chos successifs.					}
{       - La variation de hauteur entre les chos successifs.					}
{       - Le choix du canal Midi de rception.									}
{																				}
{------------------------------------------------------------------------------}
{		 GRAME 1989, Yann Orlarey et Herv Lequay								}
{}


Program Echo;

USES	Memtypes, Quickdraw, OSIntf, ToolIntf, PackIntf, Traps, MIDIShareUnit;


const	AppleID	= 128;	AppleMenu	= 1;
		FileID	= 129;	FileMenu	= 2;
		EditID	= 130;	EditMenu	= 3;
			UndoI	= 1;	CutI	= 3;	CopyI	= 4;	PasteI	= 5;	ClearI	= 6;
		
	WindowID	= 128; 					{ ID fentre de l'application		}
	AboutID		= 129;
	AlertID		= 500;
		
	resumeMask	= $01;					{ suspend/resume mask				}
		

	DelaySB 	= 1;					{ Item ScrollBar du delai			}
	VelSB 		= 2;					{ Item ScrollBar de la vlocit		}
	PitchSB 	= 3;					{ Item ScrollBar de la hauteur		}
	ChanSB 		= 4;					{ Item ScrollBar du canal Midi		}	

	DelayTXT 	= 5;					{ Item Affichage du delai			}
	VelTXT 		= 6;					{ Item Affichage de la vlocit		}
	PitchTXT 	= 7;					{ Item Affichage de la hauteur		}
	ChanTXT		= 8;					{ Item Affichage du canal Midi		}	


type
	TCtrlInfoPtr = ^TCtrlInfo;
	TCtrlInfo	= record				{ Info necessaires pour les ScrollBar	}
			val:	integer;				{ valeur courante					}
			mode:	integer;				{ 0: horizontal, 1: vertical		}
			Disp:	integer;				{ numro de l'item  mettre  jour	}
			DVal:	integer;				{ ambitus des valeur				}
			DPos: 	integer;				{ ambitus des positions				}
			oldVal:	integer;				{ valeur au dbut du Track			}
			oldPos:	integer;				{ position au dbut du Track		}
		end;
var	
	myRefNum:				integer;							{ numro d'appl. Midi				}
	myFilter: 				TFilter;							{ filtre pour les vnements Midi	}

	myWindow:	 			windowPtr;							{ fentre							}

	doneFlag:				boolean;							{ flag d'arrt						}
	
	gMac:					SysEnvRec;							{ machine							}
	eventPending:			boolean;							{ vrai si vnement en attente		}
	hasWNE:					boolean;							{ vrai si WaitNextEvent implment	}
	foreGround:				boolean;							{ vrai si en foreGround				}

	myEvent:				eventRecord;						{ pour la main event loop			}
	theChar:				char;								{ pour la gestion des touches		}
	dragRect:				rect;								{ rect de dplacement de fentre	}
	myMenus:				array[AppleMenu..EditMenu] of MenuHandle;
																{ les menus							}
	whichItem:				integer;							{ item slectionn					}
	whichCtrl:				ControlHandle;						{ Control slectionn				}
	whichInfo:				TCtrlInfoPtr;						{ infos relatives au Ctrl select.	}
	
	theDelay,
	theVel,
	thePitch,
	theChan:				TCtrlInfo;							{ info relatives aux ScrollBar		}	
	
	theDuration:			integer;							{ dure par dfaut des notes		}



(********************************************************************************)
(* 								UTILITAIRES										*)
(*------------------------------------------------------------------------------*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Function TRAPAVAILABLE (tNumber: integer; tType: trapType): boolean;
(*	Vrification de l'implmentation d'une trappe								*)
begin
	TrapAvailable:= NGetTrapAddress(tNumber,tType) <> GetTrapAddress(_Unimplemented)
end;

{$S Main}
Function ISAPPWINDOW (aWind: windowPtr): boolean;
(* vrifie si la fentre appartient  l'application								*)
begin
	if aWind = nil then
		IsAppWindow:= false
	else 
		IsAppWindow:= windowPeek(aWind)^.windowKind >= 0
end;

{$S Main}
Function ISDAWINDOW (aWind: windowPtr): boolean;
(* vrifie si la fentre appartient  un accessoire de bureau					*)
begin
	if aWind = nil then
		IsDAWindow:= false
	else 
		IsDAWindow:= windowPeek(aWind)^.windowKind < 0
end;

{$S Main}
Procedure CenterRectOnScreen (var aRect: Rect);
{ aRect rectangle global  centrer sur cran (dragRect)					}
var	screenSize	: Point;
	rectSize	: Point;
begin
	with dragRect do
		SetPt(screenSize,right - left,bottom - top);
	with aRect do begin
		SetPt(rectSize,right - left,bottom - top);
		left:= dragRect.left + (screenSize.h - rectSize.h) div 2;
		top:= dragRect.top + (screenSize.v - rectSize.v) div 5;
		topLeft:= point(PinRect(dragRect,topLeft));
		right:= left + rectSize.h;
		bottom:= top + rectSize.v;
		end;
end;

{$S Main}
Function GetNewCenteredDialog (dialogID: integer): DialogPtr;
var	dlogTemplate	: DialogTHndl;
begin
	GetNewCenteredDialog := nil;
	dlogTemplate := DialogTHndl(GetResource('DLOG', dialogID));
	if dlogTemplate <> nil then begin
		CenterRectOnScreen(dlogTemplate^^.boundsRect);
		GetNewCenteredDialog:= GetNewDialog(dialogID, nil, pointer(-1));
		end
	else SysBeep(2)												{ At least give some indication }
end;

{$S Main}
Procedure AlertUser (alertID: integer);
var	alrtTemplate	: AlertTHndl;
	temp			: integer;
begin
	alrtTemplate := AlertTHndl(GetResource('ALRT', alertID));
	if alrtTemplate <> nil then begin
		SetCursor(arrow);
		CenterRectOnScreen(alrtTemplate^^.boundsRect);
		temp:= Alert(alertID,nil)
		end
	else SysBeep(2) 											{ At least give some indication		}
end;


(********************************************************************************)
(* 								SET UP MENUS									*)
(*------------------------------------------------------------------------------*)
(* Installation de la barre de menus										  	*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Procedure SETUPMENUS;
var	i:	integer;
begin	
	myMenus[AppleMenu] := GetMenu(AppleID);						{ menu Pomme						}
	AddResMenu(myMenus[AppleMenu],'DRVR');						{ ajout des accessoires de bureau	}
	myMenus[FileMenu] := GetMenu(FileID);						{ menu Fichier						}
	myMenus[EditMenu] := GetMenu(EditID);						{ menu Edit							}
	for i := AppleMenu to EditMenu do
		InsertMenu(myMenus[i], 0);
	DrawMenuBar													{ affiche la barre des menus		}
end;
			

(********************************************************************************)
(* 								MIN et MAX										*)
(*------------------------------------------------------------------------------*)
(* Calcul du Minimum et du Maximun de deux entiers.							  	*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		n1	:	entier															*)
(*		n2	:	entier															*)
(* 																				*)
(********************************************************************************)

{$S Main}
Function Max (n1,n2: integer): integer;
begin
	if n1<n2 then Max := n2 else Max := n1
end;

Function Min (n1,n2: integer): integer;
begin
	if n1>n2 then Min := n2 else Min := n1
end;


(********************************************************************************)
(* 								SET DIA TEXT									*)
(*------------------------------------------------------------------------------*)
(* Routine pour changer le texte d'un item de dialogue.							*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		d	:	pointeur sur un dialogue.										*)
(*		i	:	numro de l'item dont on veut changer le texte.					*)
(*		s	:	chaine de caractres  placer.									*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure setDiaText (d: dialogPtr; i: integer; s: str255);
	var t: integer;
		h: handle;
		r: rect;
	begin
		getDItem(d,i,t,h,r);
		if t < statText then 
			setCTitle(controlHandle(h),s)
		else {if t < iconItem then}
			setIText(h,s);
	end;


(********************************************************************************)
(* 								SET DIA NUM										*)
(*------------------------------------------------------------------------------*)
(* Routine pour changer le texte d'un item de dialogue.							*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		d	:	pointeur sur un dialogue.										*)
(*		i	:	numro de l'item dont on veut changer le texte.					*)
(*		n	:	valeur numrique  afficher.									*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure setDiaNum (d: dialogPtr; i: integer; n: longint);
	var t: integer;
		h: handle;
		r: rect;
		s: str255;
	begin
		numToString(n,s);
		setDiaText(d,i,s);
	end;


(********************************************************************************)
(* 								ECHO NOTE										*)
(*------------------------------------------------------------------------------*)
(* La procedure de calcul de l'cho. Elle est appele sous interruptions  		*)
(* chaque rception d'une note. Ensuite, elle se rappelle rcursivement 		*)
(* pour calculer les chos suivants, par le biais d'un MidiCall qui ralise un 	*)
(* appel diffr dans le temps.													*)
(* 																				*)
(* Le principe de cette procdure d'cho est faire circuler une note			*)
(* dont la hauteur et la vlocit varient  chaque cho jusqu'a ce que l'un des	*)
(* deux paramtres sorte des bornes 0  127. De plus,  chaque cho, une copie 	*)
(* de cette note est envoye.													*)
(* 																				*)
(* Les paramtres d'un appel par le biais d'un MidiCall sont imposs, et sont 	*)
(* au nombre de cinq : la date de l'appel (longint), le numro de rfrence de 	*)
(* l'application (integer), et trois paramtres dont l'usage est libre sous    	*)
(* rserve qu'ils soient de la taille d'un longint ou d'un pointeur.			*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(* 		d:		date de l'appel (longint, en ms)								*)
(* 		myRefNum:	numro de rfrence unique de l'application (integer)		*)
(* 		e:		pointeur sur la note dont il faut calculer l'cho				*)
(*		a2,a3:	paramtres obligatoires, mais non utiliss ici.					*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure echoNote(d: longint; myRefNum: integer; e: midiEvPtr; a2,a3: longint);
var	c:		midiEvPtr;
	v,p:	integer;
begin
	c := midiCopyEv(e);											{ cre une copie de la note		}
	if c <> Nil then midiSendAt(myRefNum, c, d);				{ si la copie a russi, l'emet	}
	v := e^.vel+theVel.val;										{ calc. la nouvelle vlocit	}
	p := e^.pitch+thePitch.val;									{ calc. la nouvelle hauteur		}
	if (v>0) and (v<128) and (p>=0) and (p<128) then begin		{ si dans les limites 0..127	}
		e^.vel := v; e^.pitch := p;								{ met  jour la note			}
		midiCall (@echoNote, d+theDelay.val, myRefNum, longint(e), 0, 0) { et se rappel  la date voulue}
	end else
		midiFreeEv(e)											{ sinon, detruit la note et fin	}
end;
		
		

(********************************************************************************)
(* 							TREAT MIDI EVENTS									*)
(*------------------------------------------------------------------------------*)
(* La procedure de rception des vnements Midi. Elle est appele automatique-	*)
(* ment par MidiShare, sous	interruptions, chaque fois que l'application		*) 
(* reoit de nouveaux vnements. 												*)
(* 																				*)
(* Pour ce faire, l'adresse de cette routine  t fournie  MidiShare  		*)
(* l'ouverture de l'application par un MidiSetRcvAlarm.							*)
(* 																				*)
(* Cette procdure doit obligatoirement comporter un paramtre, qui est le 		*)
(* numro de rfrence unique de l'application (integer).						*)
(* 																				*)
(* Le principe de cette procdure est d'aller rcuprer les vnements reus,	*)
(* de vrifier qu'ils sont du bon canal et d'appeler s'il y a lieu la procdure *)
(* d'cho par le biais d'un MidiCall diffr dans le temps.						*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		myRefNum:	numro de rfrence Midi de l'application.						*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure treatMidiEvents(myRefNum: integer);
var	e:		MidiEvPtr;
	d,n: 	longint;
begin
	n := midiCountEvs(myRefNum);									{ compte les vnements reus		}
	d := midiGetTime+theDelay.val;								{ calc. la date du prochain echo	}
	while n > 0 do begin										{ tant qu'il reste des Ev  traiter	}
		e := midiGetEv(myRefNum);									{ en prendre un et :					}
		if (theChan.val<>0) and (theChan.val <> e^.chan + 1) then	{ vrifier son canal			}
			midiFreeEv(e)										{ s'il n'est pas bon, le dtruire	}
		else if e^.evType = typeNote then 						{ si c'est une note, 				}
			midiCall (@echoNote, d, myRefNum, longint(e), 0, 0)	{  appeler la proc. EchoNote 		}
		else if e^.vel>0 then begin								{ si c'est un KeyOn de vel>0		}
			e^.evType 	:= typeNote;							{  le transformer en une note		}
			e^.dur		:= theDuration;							{  dfinir une dure par defaut		}
			midiCall (@echoNote, d, myRefNum, longint(e), 0, 0)	{  appeler la proc. EchoNote		}
		   end
		else midiFreeEv(e);										{ sinon le dtruire					}
		n := n-1;
	end
end;


(********************************************************************************)
(* 							SET UP FILTERS										*)
(*------------------------------------------------------------------------------*)
(* Cette procdure dfinit les valeurs du filtre de l'application. Un filtre 	*)
(* est compos de trois parties, qui sont trois tableaux de boolens :			*) 
(* 																				*)
(*		un tableau de 256 bits pour les ports Midi accepts						*)
(*		un tableau de 256 bits pour les types d'vnements accepts				*)
(*		un tableau de  16 bits pour les canaux Midi accepts					*)
(* 																				*)
(* Les bits sont positionns  True pour accepter et  False pour refuser.	 	*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aFilter:	un filtre MidiShare.										*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
procedure setUpFilters(var aFilter: TFilter);
var i:	integer;
begin
	for i := 0 to 255 do begin					{  priori on refuse tout		}
		myFilter.port[i] := false;
		myFilter.evType[i] := false;
	end;
												{ mais on accepte				}
	myFilter.port[modemPort] 	:= true;		{ les vnements en provenance	}
	myFilter.port[printerPort] 	:= true;		{ des ports Modem et Printer	}
	
	myFilter.evType[typeNote] 	:= true;		{ les vnements de type Note	}
	myFilter.evType[typeKeyOn] 	:= true;		{ et de type Key On				}
	
	for i := 0 to 15 do begin					{ sur les 16 canaux Midi 		}
		myFilter.channel[i] := true;
	end;
												{ enfin,						}
	midisetFilter(myRefNum,@aFilter)				{ on passe le filtre  MidiShare}
end;
	
	
(********************************************************************************)
(* 								SET UP MIDI										*)
(*------------------------------------------------------------------------------*)
(* Cette procdure dfinit les diffrents paramtres necessaires au fonction-	*)
(* nement Midi de l'application. Tout d'abord, le MidiOpen de l'application		*)
(* qui lui permet de se signaler  MidiShare, et d'obtenir un numro de rf-	*)
(* rence unique pour la suite des oprations. La chaine de caractres passe en	*)
(* argument sert au catalogue des applications ouvertes que maintient MidiShare.*)
(* Ensuite la dfinition de l'alarme de rception, une procdure appele auto-	*)
(* matiquement par MidiShare,  chaque fois que l'application va recevoir de	*)
(* nouveaux vnements. Troisimement, la dfinition des filtres de rceptions	*)
(* qui permettent  l'application de spcifier  MidiShare les vnements 		*)
(* qu'elle dsire recevoir. Enfin l'tablissement des connections qui vont 		*)
(* relier l'entre et la sortie de l'application aux ports Midi externes.		*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun paramtre.														*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
procedure SetUpMidi;
var	name:		str255;
	apRefNum:	integer;
	apParam:	Handle;
	aRefNum:	integer;

	Procedure FAILSETUP (strIndex: integer);
	var	msgStr:	str255;
	begin
		GetIndString (msgStr,AlertID,strIndex);				{ message d'alerte suivant erreur	}
		ParamText(name,msgStr,'','');
		AlertUser(AlertID);
		ExitToShell												{ et quitte							}
	end;
	
begin
	GetAppParms(name,apRefNum,apParam);					{ rcuprer le nom d'application	}
	if not MidiShare then
		FailSetUp(1);									{ MidiShare n'est pas install		}
		
	myRefNum:= MidiOpen(name);							{ ouverture en Midi					}
	if myRefNum = MidiErrSpace then
		FailSetUp(2);									{ impossible, plus de place			}
	
	midiSetRcvAlarm(myRefNum, @treatMidiEvents);		{ dfinit la procdure de rception	}
	setUpFilters(myFilter);								{ programmation des filtres			}
	midiConnect(0,myRefNum,true);						{ connecte l'appl. aux entres Midi	}
	midiConnect(myRefNum,0,true);						{ connecte l'appl. aux sorties Midi }
end;


(********************************************************************************)
(* 								SET UP SCROLL BAR								*)
(*------------------------------------------------------------------------------*)
(* Cette procdure cre l'enrobage necessaire au suivi des scrollBar.			*)
(* afficheurs.																	*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		d		:	pointeur vers le dialogue concern.							*)
(*		info	:	pointeur vers info necessaires au suivi du ScrollBar.		*)
(*		me		:	numro d'item du ScrollBar.									*)
(*		disp	:	numro d'item du texte d'affichage de la valeur du ScrollB.	*)
(*		dir		:	direction du ScrollBar: 0 = horiz., 1 = vert.				*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure SetUpScrollBar(d: dialogPtr; info: TCtrlInfoPtr; me, disp: integer; dir: integer);
var	h:		controlHandle;
	t,v:	integer;
	r:		rect;
begin
	getDItem(d,me,t,handle(h),r);					{ rcupre le SB d'aprs son num. d'item}
	setCRefCon(h, longint(info));					{ lui attache les info pour le suivi.	}
	info^.val  := getCtlValue(h); 					{ rcupre la valeur courante du SB.	}
	setDiaNum(d,disp,info^.val);					{ l'affiche une premire fois.			}
	info^.mode := dir;								{ dfinit la dir. du SB (Horiz. ou Vert.)}
	info^.disp := disp;								{ dfinit l'item servant  l'affichage.	}
	info^.DVal := GetCtlMax(h)-GetCtlMin(h);		{ dfinit l'ambitus des valeurs.		}
	if dir=0 then									{ dfinit la largeur du SB.				}
		info^.Dpos := h^^.contrlRect.right - h^^.contrlRect.left - 3*16
	else
		info^.Dpos := h^^.contrlRect.bottom - h^^.contrlRect.top - 3*16;
end;


(********************************************************************************)
(* 								THUMBH ACTION									*)
(*------------------------------------------------------------------------------*)
(* Suivi du Thumb d'un ScrollBar horizontal, avec mise  jour en continu d'un	*)
(* item affichant la valeur courante.											*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucuns paramtres.														*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure thumbHAction;
var	p:		point;
	n:		longint;
	b: 		boolean;
	aEvent:	EventRecord;
begin
	getMouse(p);									{ calcul de la nouvelle valeur	}
	with whichInfo^ do n := longint(oldVal)+longint(Dval)*longint(p.h - oldPos) div longint(Dpos); 
	n := max (n, getCtlMin(whichCtrl));				{ par une rgle de trois et 	}
	n := min (n, getCtlMax(whichCtrl));				{ contrainte entre min et max.	}
	if n <> whichInfo^.val then begin				{ Si la valeur  change:		}
		whichInfo^.val := n;						{ mise  jour de la valeur		}
		setDiaNum(myWindow, whichInfo^.disp, n);	{ et affichage.					}
	end;
	if hasWNE then									{ donne la main aux autres applications }
		b:= WaitNextEvent(everyEvent, aEvent, 0, nil)
	else begin
		SystemTask;
		b:= GetNextEvent(everyEvent, aEvent)
	end;
end;												


(********************************************************************************)
(* 								THUMBV ACTION									*)
(*------------------------------------------------------------------------------*)
(* Suivi du Thumb d'un ScrollBar vertical, avec mise  jour en continu d'un		*)
(* item affichant la valeur courante.											*)
(********************************************************************************)

{$S Main}
procedure thumbVAction;
var	p:		point;
	n:		longint;
	b: 		boolean;
	aEvent:	EventRecord;
begin
	getMouse(p);									{ calcul de la nouvelle valeur	}
	with whichInfo^ do n := longint(oldVal)+longint(Dval)*longint(p.v - oldPos) div longint(Dpos); 
	n := max (n, getCtlMin(whichCtrl));				{ par une rgle de trois et 	}
	n := min (n, getCtlMax(whichCtrl));				{ contrainte entre min et max.	}
	if n <> whichInfo^.val then begin				{ Si la valeur  change:		}
		whichInfo^.val := n;						{ mise  jour de la valeur		}
		setDiaNum(myWindow, whichInfo^.disp, n);	{ et affichage.					}
	end;
	b := GetNextEvent(everyEvent, aEvent)			{ pour donner un peu la main	}
end;												{ aux autres appl.				}


(********************************************************************************)
(* 								NORMAL ACTION									*)
(*------------------------------------------------------------------------------*)
(* Suivi des autres parties d'un ScrollBar, avec mise  jour en continu d'un	*)
(* item affichant la valeur courante.											*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun paramtre.														*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure normalAction (h: controlHandle; part: integer);
var	n:		integer;
	b: 		boolean;
	aEvent:	EventRecord;
begin
	case part of
		inUpButton: 	setCtlValue(h,getCtlValue(h)-1);	{ on ralise les diffrents	}
		inDownButton: 	setCtlValue(h,getCtlValue(h)+1);	{ incrments ou dcrments	}
		inPageUp: 		setCtlValue(h,getCtlValue(h)-10);	{ de la valeur du SB, 		}
		inPageDown: 	setCtlValue(h,getCtlValue(h)+10);	{ suivant la partie clique	}
	end;
	if part <> 0 then begin									{ si une partie est clique	}
		n := getCtlValue(h);								
		if whichInfo^.val <> n then begin					{ et si la valeur du SB  	}
			whichInfo^.val := n;							{ change, alors on met 	}
			setDiaNum(myWindow, whichInfo^.disp, n);		{ jour cette valeur et on	}
		end;												{ l'affiche.				}
	end;
	b := GetNextEvent(everyEvent, aEvent)					{ pour donner un peu la main}
end;														{ aux autres appl.			}


(********************************************************************************)
(* 								TRACK DIALOG									*)
(*------------------------------------------------------------------------------*)
(* Procdure charg de trouver le scrollBar selectionn et de dclencher son	*)
(* suivi.																		*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		w	:	pointeur sur la fentre de dialogue.							*)
(*		p	:	point o la sourie  t clicke.								*)
(* 																				*)
(********************************************************************************)

{$S Main}
procedure TrackDialog(w: windowPtr; p: point);
var
	part,res:	integer;
begin
	GlobalToLocal(p);										{ conversion du point en local	}
	part := FindControl(p,w,whichCtrl);						{ cherche le SB concern		}
	if part=0 then exit(trackDialog);						{ si aucun, abandon				}
	whichInfo := TCtrlInfoPtr(getCRefCon(whichCtrl));		{ rcupere les info de ce SB	}
	if part = inThumb then begin							{ s'il faut suivre le Thumb		}
		whichInfo^.oldVal := getCtlValue(whichCtrl);		{ on rcupre la valeur actuelle}
		if whichInfo^.mode = 0 then begin					{ pour un SB horizontal:		}
			whichInfo^.oldPos := p.h;						{  on rcupre la position en x	}
			res := trackControl(whichCtrl,p,@thumbHAction)	{  et on suit le Thumb.			}
		end else begin										{ pour un SB vertical:			}
			whichInfo^.oldPos := p.v;						{  on rcupre la position en y	}			
			res := trackControl(whichCtrl,p,@thumbVAction)	{  et on suit le Thumb.			}
		end;
	end else begin											{ pour les autres parties:		}
		res := trackControl (whichCtrl,p,@normalAction);	{  on suit normalement			}
	end;
end; 
	
	
(********************************************************************************)
(* 							SET UP WINDOWS										*)
(*------------------------------------------------------------------------------*)
(* Procdure charg d'ouvrir la fentre et de raliser les initialisations 		*)
(* necessaires.																	*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun paramtre.														*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
procedure SetUpWindow;
var	r	: rect;
begin	
	with screenBits.bounds do									{ rect max de dplacmt de fentre	}
		SetRect(dragRect, 4, 24, right - 4, bottom - 4);
	myWindow := GetNewDialog(WindowID,nil,pointer(-1));
	SetPort(myWindow);
	r:= myWindow^.portRect;
	with r do begin
		LocalToGlobal(topLeft);
		LocalToGlobal(botRight)
		end;
	if not RectInRgn(r,GetGrayRgn) then begin
		CenterRectOnScreen(r);
		MoveWindow(myWindow,r.left,r.top,true)
		end;
	textFont(Monaco);
	textSize(9);
	textMode(srcCopy);
	SetUpScrollBar(myWindow, @theDelay, DelaySB, DelayTXT, 0);	{ ralise les associations	}
	SetUpScrollBar(myWindow, @theVel, VelSB, VelTXT, 0);		{ entres les 4 ScrollBars	}
	SetUpScrollBar(myWindow, @thePitch, PitchSB, PitchTXT, 0);	{ et les 4 items d'affichage}
	SetUpScrollBar(myWindow, @theChan, ChanSB, ChanTXT, 1);		{ du dialogue				}
	theDuration := 50;
	ShowWindow(myWindow)
end;

{$S Main}
Procedure SaveWindowPos;
type	rectPtr  = 	^rect;
		rectHdle =	^rectPtr;
var	windHdle:	handle;
begin
	windHdle:= Get1Resource('DLOG',WindowID);
	rectHdle(windHdle)^^:= windowPeek(myWindow)^.contRgn^^.rgnBBox;
	ChangedResource(windHdle);
	if ResError = noErr then
		WriteResource(windHdle)
end;
	

(********************************************************************************)
(* 								INITIALIZE										*)
(*------------------------------------------------------------------------------*)
(* Initialisations gnrales (hasWNE, foreGround, managers, fentre, Midi)		*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Initialize}
Procedure INITIALIZE;
var	err:	OSErr;
begin
	err:= SysEnvirons(1,gMac);
	hasWNE:= (gMac.machineType >= 0) & TrapAvailable(_WaitNextEvent,ToolTrap);
		
	InitGraf(@thePort);											{ initialisations standard			}
	InitFonts;
	InitWindows;
	InitMenus;
	TEInit;
	InitDialogs(NIL);
	InitCursor;
	SetUpMenus;													{ mise en place menus				}
	SetUpMidi;													{ ouverture MidiShare				}
	SetUpWindow;												{ initialisations fentre et listes	}
end;


(********************************************************************************)
(* 								ADJUST MENUS									*)
(*------------------------------------------------------------------------------*)
(* Ajustement de la barre de menus suivant la fentre de premier plan, juste	*)
(* lors d'un click dans la barre des menus										*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		aucun																	*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure ADJUSTMENUS;
begin
	if IsAppWindow(FrontWindow) then begin
		DisableItem(myMenus[EditMenu],UndoI);
		DisableItem(myMenus[EditMenu],CutI);
		DisableItem(myMenus[EditMenu],CopyI);
		DisableItem(myMenus[EditMenu],PasteI);
		DisableItem(myMenus[EditMenu],ClearI)
		end
	else
	if IsDAWindow(FrontWindow) then begin
		EnableItem(myMenus[EditMenu],UndoI);
		EnableItem(myMenus[EditMenu],CutI);
		EnableItem(myMenus[EditMenu],CopyI);
		EnableItem(myMenus[EditMenu],PasteI);
		EnableItem(myMenus[EditMenu],ClearI)
		end
end;
			

(********************************************************************************)
(* 								DO COMMAND										*)
(*------------------------------------------------------------------------------*)
(* Gre les menus: Pomme (About), File (Quit)									*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		mResult: numro de menu et d'item retourns par MenuSelect et MenuKey	*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure DOCOMMAND ( mResult: LONGINT);
var	theItem:	integer;
	name:		str255;
	sysEdit:	boolean;
	
	Procedure SHOWABOUT;
	var	myDialog	: dialogPtr;
		hit			: integer;
	begin
		myDialog:= GetNewCenteredDialog(AboutID);
		if myDialog <> nil then begin
			ModalDialog(nil,hit);
			DisposDialog(myDialog);
			end
	end;

begin	
	theItem := LoWord(mResult);
	case HiWord(mResult) of
		AppleID:												{ menu Pomme						}
			if theItem <> 1 then begin
				GetItem(myMenus[AppleMenu], theItem, name);
				theItem := OpenDeskAcc(name)  end
			else ShowAbout;
		FileID:													{ menu File							}
			doneFlag := true;
		EditID:													{ menu Edit: uniquement pour DAs	}
			sysEdit := SystemEdit(theItem-1);
		end;
	HiliteMenu(0)
end;
		
		
(********************************************************************************)
(* 								DO MOUSE DOWN									*)
(*------------------------------------------------------------------------------*)
(* Gre les clicks souris														*)
(* 																				*)
(* Les paramtres de l'appel :													*)
(* ---------------------------													*)
(* 																				*)
(*		anEvent: l'vnement													*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure DOMOUSEDOWN (anEvent: eventRecord);
var	whichWind:	windowPtr;
	part:		integer;
begin
	part:= FindWindow(anEvent.where, whichWind);
	case part of
		inMenuBar:		begin
						AdjustMenus;
						DoCommand(MenuSelect(anEvent.where))
						end;
		inSysWindow:	SystemClick(anEvent,whichWind);
		inDrag: 		DragWindow(whichWind,anEvent.where,dragRect);
		inGoAway:		if IsAppWindow(whichWind) then 
							doneFlag:= TrackGoAway(whichWind,anEvent.where);
		inContent:		if whichWind <> FrontWindow then
							SelectWindow(whichWind)
						else
							TrackDialog(whichWind,anEvent.where)
		end
end;


(********************************************************************************)
(* 								ADJUST CURSOR									*)
(*------------------------------------------------------------------------------*)
(* Ajuste le curseur suivant rgion et fentre									*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure ADJUSTCURSOR;
begin
	if foreGround and IsAppWindow(FrontWindow) then
		SetCursor(arrow)
end;


(********************************************************************************)
(* 								CLOSE WINDOWS									*)
(*------------------------------------------------------------------------------*)
(* Pour terminer correctement l'application: fermeture de toutes les fentres	*)
(* (application et DA's)														*)
(* 																				*)
(********************************************************************************)

{$S Main}
Procedure CLOSEWIND (aWind: windowPtr);
(* ferme une fentre															*)
begin
	if IsDAWindow(aWind) then
		CloseDeskAcc(windowPeek(aWind)^.windowKind)
	else if IsAppWindow(aWind) then
		DisposeWindow(aWind)
end;

Procedure CLOSEALLWINDS;
(* ferme toutes les fentres													*)
var	window:	windowPtr;
begin
	repeat
		window:= FrontWindow;
		if window <> nil then
			CloseWind(window);
	until window = nil;
end;


Procedure _DataInit;		EXTERNAL;


(********************************************************************************)
(* 						Corps principal du programme							*)
(*------------------------------------------------------------------------------*)
(* Ouverture des diffrents managers, Initialisations diverses et boucle prin-	*)
(* cipale typique d'une application Macintosh.							 		*)
(********************************************************************************)
	
{$S Main}
begin
	UnLoadSeg(@_DataInit);
	MaxApplZone;
	Initialize;
	UnLoadSeg(@Initialize);
	
	DoneFlag:=false;											{ flag de terminaison				}
	repeat														{ boucle principale typique			}
		if hasWNE then
			eventPending:= WaitNextEvent(everyEvent, myEvent, 0, nil)
																{ no sleep, no mouseRgn				}
		else begin
 			SystemTask;
	 		eventPending:= GetNextEvent(everyEvent, myEvent)
		end;
		AdjustCursor;											{ si  curseurs ou mouseRgn, ici	}
		with myEvent do
			case what of
				osEvt:
					case BSR(message,24) of
						suspendResumeMessage:
							begin
							foreGround:= BAnd(message,resumeMask) <> 0;
							end;
					end;
				keyDown, autoKey:
					if IsAppWindow(FrontWindow) then begin
						theChar:= chr(BAnd(message,charCodeMask));
						IF BAnd(modifiers, cmdKey) <> 0 then
							DoCommand(MenuKey(theChar))
					end;
				mouseDown:
					DoMouseDown(myEvent);
				updateEvt:
					if IsAppWindow(windowPtr(message)) then begin
						BeginUpdate(windowPtr(message));
						if not EmptyRgn(windowPtr(message)^.visRgn) then begin
							SetPort(windowPtr(message));
							DrawDialog(windowPtr(message));
						end;
						EndUpdate(windowPtr(message))
					end
				end
	until doneFlag;
	MidiClose(myRefNum);												{ fermeture MidiShare 			}
	SaveWindowPos;
	CloseAllWinds;
	ExitToShell
end.

