/********************************************************************************/
/*                                  ECHO                                        */
/*------------------------------------------------------------------------------*/
/* 																				*/
/* Le programme ECHO prsent ici, fait partie d'une srie d'exemples  		*/
/* caractre pdagogique sur la faon d'utiliser MIDISHARE.						*/
/* 																				*/
/* Comme son nom l'indique, ECHO effectue un cho temps-rel sur les notes		*/
/* reues. Il dispose de quatre types de controles :							*/
/*       - Le delai entre les chos successifs (en millisecondes)               */
/*       - La variation de vlocit entre les chos successifs.					*/
/*       - La variation de hauteur entre les chos successifs.					*/
/*       - Le choix du canal Midi de rception.									*/
/*																				*/
/*------------------------------------------------------------------------------*/
/*		 GRAME 1989, Yann Orlarey et Herv Lequay								*/
/********************************************************************************/

/*
 derez -s CODE msecho 
	{RIncludes}SysTypes.r 
	{RIncludes}Types.r 
	> msecho.r
*/

#include "Types.r"
#include "SysTypes.r"


resource 'MENU' (128, "Apple", preload) {
	128,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	apple,
	{	/* array: 2 elements */
		/* [1] */
		"A propos de msEcho", noIcon, noKey, noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain
	}
};

resource 'MENU' (129, "File", preload) {
	129,
	textMenuProc,
	allEnabled,
	enabled,
	"Fichier",
	{	/* array: 1 elements */
		/* [1] */
		"Quitter", noIcon, "Q", noMark, plain
	}
};

resource 'MENU' (130, "Edit", preload) {
	130,
	textMenuProc,
	0x7FFFFFFD,
	enabled,
	"Edit",
	{	/* array: 6 elements */
		/* [1] */
		"Annuler", noIcon, "Z", noMark, plain,
		/* [2] */
		"-", noIcon, noKey, noMark, plain,
		/* [3] */
		"Couper", noIcon, "X", noMark, plain,
		/* [4] */
		"Copier", noIcon, "C", noMark, plain,
		/* [5] */
		"Coller", noIcon, "V", noMark, plain,
		/* [6] */
		"Effacer", noIcon, noKey, noMark, plain
	}
};

resource 'DLOG' (128, "Main") {
	{124, 148, 221, 490},
	documentProc,
	invisible,
	goAway,
	0x0,
	128,
	"Echo"
};

resource 'DLOG' (129, "About") {
	{29, 31, 329, 487},
	plainDBox,
	visible,
	goAway,
	0x0,
	129,
	""
};

resource 'DITL' (500, "Errors") {
	{	/* array DITLarray: 3 elements */
		/* [1] */
		{52, 187, 73, 249},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{9, 52, 42, 255},
		StaticText {
			disabled,
			"Impossible de lancer ^0:\n^1."
		},
		/* [3] */
		{6, 8, 38, 40},
		Icon {
			disabled,
			500
		}
	}
};

resource 'DITL' (128, "Main") {
	{	/* array DITLarray: 9 elements */
		/* [1] */
		{28, 8, 44, 174},
		Control {
			enabled,
			140
		},
		/* [2] */
		{51, 8, 67, 174},
		Control {
			enabled,
			141
		},
		/* [3] */
		{74, 8, 90, 174},
		Control {
			enabled,
			142
		},
		/* [4] */
		{26, 317, 90, 333},
		Control {
			enabled,
			143
		},
		/* [5] */
		{31, 187, 43, 213},
		StaticText {
			disabled,
			"500"
		},
		/* [6] */
		{54, 187, 66, 213},
		StaticText {
			disabled,
			"-4"
		},
		/* [7] */
		{77, 187, 89, 213},
		StaticText {
			disabled,
			"12"
		},
		/* [8] */
		{77, 282, 89, 308},
		StaticText {
			disabled,
			"15"
		},
		/* [9] */
		{5, 7, 90, 311},
		Picture {
			disabled,
			128
		}
	}
};

resource 'DITL' (129, "About", preload) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{-1, -1, 301, 457},
		Picture {
			enabled,
			129
		},
		/* [2] */
		{11, 7, 43, 39},
		Icon {
			enabled,
			128
		}
	}
};

resource 'CNTL' (140) {
	{320, 80, 336, 246},
	80,
	visible,
	2000,
	0,
	scrollBarProc,
	0,
	"delay"
};

resource 'CNTL' (141) {
	{320, 80, 336, 246},
	-4,
	visible,
	127,
	-127,
	scrollBarProc,
	0,
	"vel"
};

resource 'CNTL' (142) {
	{320, 80, 336, 246},
	0,
	visible,
	127,
	-127,
	scrollBarProc,
	0,
	"pitch"
};

resource 'CNTL' (143) {
	{16, 0, 80, 16},
	1,
	visible,
	16,
	0,
	scrollBarProc,
	0,
	"chan"
};

resource 'PICT' (128, "Main") {
	1237,
	{0, 7, 85, 311},
	$"1101 A000 82A0 3039 A000 8E01 000A 0000"
	$"0000 02F0 0240 9800 2800 0000 0000 5501"
	$"3800 0000 0700 5501 3700 0000 0700 5501"
	$"3700 0107 0301 FF00 38DD 0007 0300 C100"
	$"18DD 0007 0300 C100 18DD 0007 0300 C000"
	$"18DD 0007 0300 C200 18DD 0014 1000 C21F"
	$"19C0 F01D F398 F07C 3E0F 0F07 8E60 EA00"
	$"1410 00FE 319A E318 0E39 BB18 C663 31B1"
	$"98C6 E0EA 0013 0F00 C220 1C62 0C0C 19C2"
	$"0C80 41B0 3010 67E9 0013 0F00 C260 1866"
	$"0C0C 1986 0D80 C1B8 3830 66E9 0013 0F00"
	$"C060 1866 0C0C 1986 0D80 FF9F 1F30 66E9"
	$"0013 0F00 C060 1866 0C0C 1986 0D80 C003"
	$"83B0 66E9 0013 0F00 C170 1866 080C 1186"
	$"09C0 E001 81B0 46E9 0013 0F00 C138 9863"
	$"180C 6183 18E2 70B1 B198 C6E9 0013 0F01"
	$"FF1F 3C71 E00F C3C1 E07C 3F1E 1E0F 0FE9"
	$"0006 FB00 000C E000 06FB 0000 0CE0 0006"
	$"FB00 000C E000 06FB 0000 0CE0 0006 FB00"
	$"001E E000 02D9 0002 D900 02D9 0008 EB00"
	$"0001 FDFF F400 08EB 0000 01FD FFF4 000D"
	$"EB00 0701 8000 0001 00C0 18F7 000D EB00"
	$"0701 8000 0001 0040 08F7 000D EB00 0701"
	$"8000 0001 0040 08F7 000D EB00 0701 8000"
	$"0001 0040 08F7 000F EB00 0901 8000 0001"
	$"03C3 8873 9CF9 000F EB00 0901 8000 0001"
	$"044C C899 08F9 000F EB00 0901 8000 0001"
	$"0848 4809 90F9 000F EB00 0901 8000 0001"
	$"084F C8F8 90F9 000F EB00 0901 8000 0001"
	$"0848 0908 A0F9 000F EB00 0901 8000 0001"
	$"0CCC 4998 60F9 000F EB00 0901 8000 0001"
	$"0767 9CEC 40F9 000E EB00 0401 8000 0001"
	$"FD00 0040 F900 0EEB 0004 0180 0000 01FD"
	$"0000 80F9 000E EB00 0401 8000 0001 FD00"
	$"0080 F900 0CEB 0000 01FD FFFE 0000 03F8"
	$"0002 D900 02D9 0002 D900 02D9 0002 D900"
	$"02D9 0008 EB00 0001 FDFF F400 08EB 0000"
	$"01FD FFF4 000A EB00 0401 8000 0001 F400"
	$"0DEB 0007 0180 0000 0100 0018 F700 0DEB"
	$"0007 0180 0000 0100 0008 F700 0DEB 0007"
	$"0180 0000 0100 0008 F700 0DEB 0007 0180"
	$"0000 0100 0008 F700 0DEB 0007 0180 0000"
	$"010E E388 F700 0DEB 0007 0180 0000 0104"
	$"4CC8 F700 11EB 0007 0180 0000 0104 4848"
	$"FC00 0003 FD00 11EB 0007 0180 0000 0102"
	$"8FC8 FC00 0001 FD00 11EB 0007 0180 0000"
	$"0102 8808 FC00 0001 FD00 12EB 0008 0180"
	$"0000 0101 0C48 80FD 0000 01FD 0014 EB00"
	$"0801 8000 0001 0107 9C80 FD00 0439 60E3"
	$"6000 10EB 0004 0180 0000 01F9 0004 C991"
	$"3190 0010 EB00 0401 8000 0001 F900 0481"
	$"1011 1000 0EEB 0000 01FD FFF9 0004 8111"
	$"F110 0008 DE00 0481 1211 1000 08DE 0004"
	$"C113 3110 0008 DE00 047B 99DB 9800 02D9"
	$"0002 D900 02D9 000F EB00 0001 FDFF FA00"
	$"0003 FEFF 01FE 000F EB00 0001 FDFF FA00"
	$"0003 FEFF 01FE 0015 EB00 0401 8000 0001"
	$"FE00 0018 FE00 0003 FE00 0102 0015 EB00"
	$"0801 8000 0001 0004 0008 FE00 0003 FE00"
	$"0102 0015 EB00 0801 8000 0001 0004 4008"
	$"FE00 0003 FE00 0102 0015 EB00 0801 8000"
	$"0001 0000 4008 FE00 0003 FE00 0102 0015"
	$"EB00 0801 8000 0001 0DCC F1CB FE00 0003"
	$"FE00 0102 0015 EB00 0C01 8000 0001 0664"
	$"464C 8000 0003 FE00 0102 0015 EB00 0C01"
	$"8000 0001 0424 4408 8000 0003 FE00 0102"
	$"0015 EB00 0C01 8000 0001 0424 4408 8000"
	$"0003 FE00 0102 0015 EB00 0C01 8000 0001"
	$"0424 4408 8000 0003 FE00 0102 0015 EB00"
	$"0C01 8000 0001 0444 4608 8000 0003 FE00"
	$"0102 0015 EB00 0C01 8000 0001 078E 33DC"
	$"C000 0003 FE00 0102 0012 EB00 0501 8000"
	$"0001 04FB 0000 03FE 0001 0200 12EB 0005"
	$"0180 0000 0104 FB00 0003 FE00 0102 0012"
	$"EB00 0501 8000 0001 04FB 0000 03FE 0001"
	$"0200 11EB 0000 01FD FF00 0EFB 0000 03FE"
	$"FF01 FE00 A000 8FA0 0083 FF"
};

resource 'PICT' (129) {
	6686,
	{21, 40, 323, 498},
	$"0011 02FF 0C00 FFFF FFFF 0028 0000 0015"
	$"0000 01F2 0000 0143 0000 0000 0000 0001"
	$"000A 0015 0028 0143 01F2 0098 003A 0015"
	$"0028 0143 01F2 0015 0028 0143 01F2 0015"
	$"0028 0143 01F2 0000 04C8 FF00 C004 C8FF"
	$"00C0 04C8 FF00 C004 C8FF 00C0 04C8 FF00"
	$"C004 C8FF 00C0 04C8 FF00 C004 C8FF 00C0"
	$"04C8 FF00 C004 C8FF 00C0 04C8 FF00 C004"
	$"C8FF 00C0 04C8 FF00 C004 C8FF 00C0 08F0"
	$"FF00 F3DA FF00 C00D F5FF 05E0 0003 FFFF"
	$"03DA FF00 C00D F5FF 05FC 0003 FFFF E3DA"
	$"FF00 C00D F5FF 05FC 7FF3 FFFF E3DA FF00"
	$"C00D F5FF 05FC 7FFB FFFF E3DA FF00 C00D"
	$"F5FF 05FC 7FFB FFFF E3DA FF00 C00D F5FF"
	$"05FC 7FFB FFFF E3DA FF00 C00D F5FF 01FC"
	$"7FFE FF00 E3DA FF00 C00D F5FF 01FC 7FFE"
	$"FF00 E3DA FF00 C017 FBFF 0FFE 707E 0FFF"
	$"03FC 7FDF FF03 E3C1 FFF0 1FDE FF00 C017"
	$"FBFF 0FE0 601C 03FC 78FC 7FDF FC01 E300"
	$"FFCF 87DE FF00 C025 FBFF 0FFC 5E0B C3F9"
	$"FCFC 7FDF F3E1 E278 7F9F E3F3 FF03 8F17"
	$"CDC0 F9FF 03C7 E7FF 9FFC FF00 C026 FBFF"
	$"0FFC 3F07 E1F1 FEFC 001F E7FB E1FC 3F3F"
	$"E1F3 FF03 CF3F EFBA FAFF 04FD F7F7 FF7F"
	$"FCFF 00C0 26FB FF0F FC7F 8FF1 F1FE FC00"
	$"1FC7 FBE3 FE3E 7FF1 F3FF 03CF 3FEF BEFA"
	$"FF04 FDF7 F7FF 7FFC FF00 C02E FBFF 0FFC"
	$"7F8F F1F0 FFFC 7FDF CFFB E3FE 3E7F F0F5"
	$"FF17 FE1F D6B7 0DDE 9874 CFC6 1933 A218"
	$"5477 3E14 CF31 A03A 67C0 2DFB FF0F FC7F"
	$"8FF1 F03F FC7F DF8F FFE3 FE3C 7FF8 F4FF"
	$"16DF D6A6 E9E6 6F62 B7B5 ECCD 1DDD 93B6"
	$"DF62 B6DB 37B1 5BC0 2DFB FF0F FC7F 8FF1"
	$"F803 FC7F DF8F FFE3 FE3C 7FF8 F4FF 161F"
	$"D6B5 EDFA EC77 87B5 EDDD BD1D D7B6 1F77"
	$"861B 563B C3C0 2EFB FF0F FC7F 8FF1 FC00"
	$"FC7F FF8F FFE3 FE3C 7FF8 F5FF 17FE DFD9"
	$"B5ED FAEB 77BF BDED DDBC DDD7 B6FF 77BE"
	$"FAD5 BBDF C02E FBFF 0FFC 7F8F F1FF 807C"
	$"7FFF 8FFF E3FE 3C7F F8F5 FF17 FEDF D9B5"
	$"CDBA EB77 BFBD EDDD BADD D776 FF77 BEFC"
	$"CDBB DFC0 2EFB FF0F FC7F 8FF1 FFF8 7C7F"
	$"FF8F FFE3 FE3C 7FF8 F5FF 17FE 0F8F 0220"
	$"8460 23C7 C618 8C86 0E00 E31E 23C7 1DEC"
	$"11E3 C01B FBFF 0FFC 7F8F F1F7 FC7C 7FFB"
	$"87FF E3FE 3C3F F9E9 FF00 BFF7 FF00 C01B"
	$"FBFF 0FFC 7F8F F1F7 FC7C 7FFB C7FF E3FE"
	$"3E3F F9E9 FF00 BFF7 FF00 C01B FBFF 0FFC"
	$"7F8F F1F7 FCFC 7FF3 C3FF E3FE 3E1F F3E9"
	$"FF00 1FF7 FF00 C017 FBFF 0FFC 7F8F F1F3"
	$"F8FC 7FF3 E0F9 E3FE 3F0F E7DE FF00 C017"
	$"FBFF 02FC 7F8F FEF1 09FC 0003 F003 E3FE"
	$"3F87 CFDE FF00 C017 FBFF 0FE0 0C01 F03C"
	$"07E0 0003 FC0F 007E 07E0 3FDE FF00 C004"
	$"C8FF 00C0 04C8 FF00 C004 C8FF 00C0 04C8"
	$"FF00 C004 C8FF 00C0 04C8 FF00 C01E E2FF"
	$"06E0 7FFF FE9F FF07 FEFF 10F8 FEFF FFCF"
	$"E6FF 3FFD FFFF 9FFF 83FF FFC0 2CFB FF0A"
	$"F83F C183 F7C7 881F BC71 F7F3 FF06 F77F"
	$"FFFF DFFE F7FE FF10 E77D 7FFF EFF7 FFBF"
	$"FAFF FFDF FE7B FFFF C02B FBFF 0AF7 DFBD"
	$"DDEB E79D DE3B AEE7 F3FF 00F7 FEFF 01DF"
	$"FDFD FF0C E8BD 7FFF EFF7 FFBF FAFF FFDF"
	$"FDFE FF00 C02C FBFF 0AEC 6F7F DDEB E79D"
	$"FFBB AEE7 F3FF 1AF6 F933 0EDF 7DFE 8193"
	$"3CD6 BD7A 346E 76D3 B3FA F468 DCFD FE19"
	$"33C0 2CFB FF0A EBAF 7FDD EBEB 5DBF BBAE"
	$"D7F3 FF1A F0FC CDEC DFFD FC5D CCDB 55BB"
	$"B1C3 ADB4 8DAF F763 875B 7DFD ECCD C02C"
	$"FBFF 0AEB EF7F D3DD EB5C 3FBB AED7 F3FF"
	$"1AF6 8DDD 8EDF FDE2 F1DD D855 783B D7AC"
	$"36DD 9FF0 77AF 587D FDED DDC0 2CFB FF0A"
	$"EBAF 78D7 C1EB 5DBF BC30 B7F3 FF1A F7FD"
	$"DD6E DFFD F6ED DDDB D077 DBD7 ADF6 DDAF"
	$"EFB7 AF5B FDFD EDDD C02C FBFF 0AEC 6F7D"
	$"DBBE ECDD FFBF 7D83 F3FF 1AF7 7DDD 6EDF"
	$"FEF6 EDDD DBEF F7DB B76D F6DD B7EF B76E"
	$"DBFE FDED DDC0 2CFB FF0A F7DF BDDD BEEC"
	$"DDDF BEFB F7F3 FF1A E078 8C04 0F7F 0C60"
	$"88CC 7063 8870 C620 0C19 4710 E18C 6F02"
	$"188C C01C FBFF 0AF8 3FC3 8E1C 4788 1F19"
	$"E7E3 E7FF 01FB F7FC FF01 F7EF FCFF 00C0"
	$"0ED6 FF01 FBF7 FCFF 01F7 EFFC FF00 C00E"
	$"D6FF 01F1 E3FC FF01 E3C7 FCFF 00C0 04C8"
	$"FF00 C002 C700 02C7 0002 C700 02C7 0002"
	$"C700 02C7 0002 C700 02C7 0002 C700 08DD"
	$"0000 03F7 FFF6 0012 0200 007F F8FF 0080"
	$"EA00 0002 F800 0001 F600 1202 0000 40F8"
	$"0000 80EA 0000 02F8 0000 01F6 0012 0200"
	$"0040 F800 0080 EA00 0002 F800 0001 F600"
	$"1E0C 0000 4F80 6000 0006 0001 0000 80EA"
	$"000A 021E C000 000C 0018 0000 01F6 001D"
	$"0700 0044 4020 0000 02FD 0000 80EA 000A"
	$"0222 4000 0004 0008 0080 01F6 001D 0700"
	$"0044 2020 0000 02FD 0000 80EA 000A 0240"
	$"4000 0004 0008 0080 01F6 001E 0C00 0044"
	$"262F 6E37 F2D9 836C 0080 EA00 0A02 405B"
	$"DB6C C41D 898F DDE1 F600 1E0C 0000 4429"
	$"2124 1212 4A41 3400 80EA 000A 0240 684D"
	$"3524 224A 52A2 81F6 001E 0C00 0044 2F27"
	$"2812 724B C124 0080 EA00 0A02 4049 C925"
	$"E413 CBD0 A281 F600 1E0C 0000 4448 2928"
	$"0C92 4A01 2400 80EA 000A 0220 4A49 2504"
	$"0E0A 10A2 81F6 001E 0C00 004F 877F 900C"
	$"FF3D C3F6 0080 EA00 0A02 1EEF FDF6 EE39"
	$"DDCE DDC1 F600 1505 0000 4000 0010 FB00"
	$"0080 EA00 0002 F800 0001 F600 1505 0000"
	$"4000 0050 FB00 0080 EA00 0002 F800 0001"
	$"F600 1505 0000 4000 0060 FB00 0080 EA00"
	$"0002 F800 0001 F600 1D04 0000 4002 D9FE"
	$"0000 0CFE 0000 80EA 0001 0216 FD00 0403"
	$"CE3F 3F81 F600 1D04 0000 4000 48FE 0000"
	$"04FE 0000 80EA 0001 0219 FD00 0404 2633"
	$"1281 F600 1D04 0000 4000 48FE 0000 04FE"
	$"0000 80EA 0001 0229 FD00 0408 1632 9241"
	$"F600 1E0C 0000 4DB6 4B3B 1DDB 3CE0 0000"
	$"80EA 000A 0229 0DB3 3DB3 8815 5292 41F6"
	$"001E 0800 0046 D249 44A6 2D45 FE00 0080"
	$"EA00 0A02 2906 D484 D408 1552 5241 F600"
	$"1E0C 0000 4492 4927 A229 4480 0000 80EA"
	$"000A 0229 0497 9C92 0815 5252 41F6 001E"
	$"0C00 0044 9249 1C22 294C 6000 0080 EA00"
	$"0A02 2904 9424 9184 2492 3241 F600 1E0C"
	$"0000 4EDF FFF3 9DDD B7C0 0000 80EA 000A"
	$"0226 0EDB BFDF 03CE BF17 41F6 0013 0200"
	$"0040 F800 0080 EA00 0102 10F9 0000 81F6"
	$"0013 0200 0040 F800 0080 EA00 0102 10F9"
	$"0000 81F6 0012 0200 0040 F800 0080 EA00"
	$"0002 F800 0001 F600 1202 0000 40F8 0000"
	$"80EA 0000 02F8 0000 01F6 0012 0200 0040"
	$"F800 0080 EA00 0002 F800 0001 F600 1202"
	$"0000 40F8 0000 80EA 0000 02F8 0000 01F6"
	$"0010 0200 0040 F800 0080 EA00 0003 F7FF"
	$"F600 0E02 0000 7FF8 FF00 80E0 0000 01F6"
	$"000A F600 0080 DF00 0001 F600 0AF6 0000"
	$"80DF 0000 01F6 000A F600 0080 DE00 0080"
	$"F700 0AF6 0000 80DE 0000 80F7 000A F600"
	$"0040 DE00 0080 F700 0AF6 0000 40DE 0000"
	$"80F7 000A F600 0040 DE00 0080 F700 0AF6"
	$"0000 40DE 0000 80F7 000A F600 0040 DE00"
	$"0080 F700 0AFA 0000 07D7 FF00 F8FA 0011"
	$"FA00 0004 FE00 0020 DE00 0340 0000 0CFA"
	$"0011 FA00 0004 FE00 0020 DE00 0340 0000"
	$"0CFA 0011 FA00 0004 FE00 0020 DE00 0340"
	$"0000 0CFA 0015 FA00 0305 FBFF BFF2 FF00"
	$"F0FD 0000 03EF FF00 ECFA 0017 FA00 0404"
	$"0200 8020 F200 021F 0060 F000 0340 0000"
	$"0CFA 0016 FA00 0305 FA00 BFF2 FF05 F018"
	$"0060 0003 EFFF 00EC FA00 18FA 0004 0402"
	$"0080 10F2 0003 181C 7C3C F100 0320 0000"
	$"0CFA 0016 FA00 0305 FA00 BFF2 FF05 F018"
	$"3266 6603 EFFF 00EC FA00 18FA 0004 0402"
	$"0080 10F2 0003 1E30 6666 F100 0320 0000"
	$"0CFA 0016 FA00 0305 FA00 BFF2 FF05 F018"
	$"3066 6603 EFFF 00EC FA00 18FA 0004 0402"
	$"0080 10F2 0003 1830 6666 F100 0320 0000"
	$"0CFA 0016 FA00 0305 FA00 BFF2 FF05 F018"
	$"3266 6603 EFFF 00EC FA00 18FA 0004 0402"
	$"0080 08F2 0003 1F1C 663C F100 0320 0000"
	$"0CFA 0015 FA00 0305 FBFF BFF2 FF00 F0FD"
	$"0000 03EF FF00 ECFA 0011 FA00 0004 FE00"
	$"0008 DE00 0310 0000 0CFA 0011 FA00 0004"
	$"FE00 0008 DE00 0310 0000 0CFA 0011 FA00"
	$"0004 FE00 0008 DE00 0310 0000 0CFA 000A"
	$"FA00 0007 D7FF 00FC FA00 11FA 0000 04FE"
	$"0000 04DE 0003 1000 000C FA00 11FA 0000"
	$"04FE 0000 04DE 0003 1000 000C FA00 11FA"
	$"0000 04FE 0000 04DE 0003 1000 000C FA00"
	$"11FA 0000 04FE 0000 04DE 0003 0800 000C"
	$"FA00 11FA 0000 04FE 0000 04DE 0003 0800"
	$"000C FA00 11FA 0004 0407 FC00 E2DE 0003"
	$"0800 000C FA00 11FA 0004 0403 0400 62DE"
	$"0003 0800 000C FA00 11FA 0004 0403 0400"
	$"62DE 0003 0800 000C FA00 11FA 0004 0403"
	$"0000 62DE 0003 0800 000C FA00 11FA 0004"
	$"0403 0800 62DE 0003 0800 000C FA00 1EFA"
	$"0011 0403 087C 6703 C077 CE63 C1F0 F83C"
	$"3C1E 3980 EB00 0304 0000 0CFA 001E FA00"
	$"1104 03F8 C66B 8C60 38E6 EC63 198C C6C6"
	$"631B 80EB 0003 0400 000C FA00 1DFA 0010"
	$"0403 0880 7188 3030 6708 3201 06C0 C041"
	$"9CEA 0003 0400 000C FA00 1DFA 0010 0403"
	$"0980 6198 3030 6618 3603 06E0 E0C1 98EA"
	$"0003 0400 000C FA00 1DFA 0010 0403 0180"
	$"6198 3030 6618 3603 FE7C 7CC1 98EA 0003"
	$"0400 000C FA00 1DFA 0010 0403 0180 6198"
	$"3030 6618 3603 000E 0EC1 98EA 0003 0400"
	$"000C FA00 1DFA 0010 0403 05C0 6198 2030"
	$"4618 2703 8006 06C1 18EA 0003 0400 000C"
	$"FA00 1DFA 0010 0403 04E2 618C 6031 860C"
	$"6389 C2C6 C663 18EA 0003 0200 000C FA00"
	$"1DFA 0010 0407 FC7C F1C7 803F 0F07 81F0"
	$"FC78 783C 3CEA 0003 0200 000C FA00 13FA"
	$"0000 04FD 0002 8000 30E1 0003 0200 000C"
	$"FA00 13FA 0000 04FD 0002 8000 30E1 0003"
	$"0200 000C FA00 13FA 0000 04FD 0002 8000"
	$"30E1 0003 0200 000C FA00 13FA 0000 04FD"
	$"0002 4000 30E1 0003 0200 000C FA00 13FA"
	$"0000 04FD 0002 4000 78E1 0003 0200 000C"
	$"FA00 11FA 0000 04FD 0000 40DF 0003 0200"
	$"000C FA00 11FA 0000 04FD 0000 40DF 0003"
	$"0100 000C FA00 11FA 0000 04FD 0000 40DF"
	$"0003 1FFF E00C FA00 19FA 0000 04FD 0000"
	$"40F0 0000 07FE FF00 FCF5 0003 1100 200C"
	$"FA00 17FA 0001 0403 EDFF 01F0 07FE FF00"
	$"FCF5 0003 1100 200C FA00 20FA 0006 0402"
	$"0004 9FFF E8F3 8802 0010 06FE 0003 0403"
	$"0060 F800 0311 3020 0CFA 0020 FA00 0504"
	$"0204 0630 20F3 2203 2808 1006 FE00 0304"
	$"0100 20F8 0003 1148 200C FA00 20FA 0006"
	$"0402 0C04 9020 28F3 8802 0C10 06FE 0003"
	$"0401 0020 F800 0311 8420 0CFA 0020 FA00"
	$"0504 0214 0630 24F3 2203 280A 1006 FE00"
	$"0304 0100 20F8 0003 1182 200C FA00 22FA"
	$"0006 0402 27C4 9124 28F3 880B F910 061C"
	$"7000 040F 0E21 CE70 FA00 0312 8120 0CFA"
	$"0022 FA00 0504 0240 4630 98F3 220C 2880"
	$"9006 2288 0004 1133 2264 20FA 0003 1787"
	$"A00C FA00 22FA 0006 0402 8044 90D8 28F3"
	$"880B 8050 0622 8800 0421 2120 2640 FA00"
	$"0310 8420 0CFA 0022 FA00 0504 0280 4630"
	$"78F3 220C 2880 5006 1C88 0004 213F 23E2"
	$"40FA 0003 1084 200C FA00 22FA 0006 0402"
	$"4044 9038 28F3 880B 8090 0622 8800 0421"
	$"2024 2280 FA00 0310 8420 0CFA 0022 FA00"
	$"0504 0227 C630 38F3 220C 28F9 1006 2288"
	$"0004 3331 2661 80FA 0003 10FC 200C FA00"
	$"21FA 0006 0402 1404 9018 28F3 880A 0A10"
	$"061C 7000 041D 9E73 B1F9 0003 1040 200C"
	$"FA00 21FA 0005 0402 0C06 3010 F322 0328"
	$"0C10 06FE 0000 04FE 0000 01F9 0003 1040"
	$"200C FA00 21FA 0006 0402 0404 9000 28F3"
	$"8802 0810 06FE 0000 04FE 0000 02F9 0003"
	$"1FFF E00C FA00 22FA 0006 0402 0006 3FFF"
	$"E2F4 2203 2800 1006 FE00 0004 FE00 0002"
	$"F900 0312 6220 0CFA 001B FA00 0104 03ED"
	$"FF01 F007 FEFF 00FC FE00 000C F900 031F"
	$"FFE0 0CFA 000D FA00 0004 DA00 0318 4060"
	$"0CFA 000D FA00 0004 DA00 0318 4460 0CFA"
	$"000D FA00 0004 DA00 031A 2860 0CFA 000D"
	$"FA00 0004 DA00 0319 2860 0CFA 000D FA00"
	$"0004 DA00 0319 B860 0CFA 000D FA00 0004"
	$"DA00 0318 F860 0CFA 0015 FA00 0004 EB00"
	$"0007 FEFF 00FC F500 0318 7060 0CFA 0017"
	$"FA00 0104 03ED FF01 F007 FEFF 00FC F500"
	$"0318 7060 0CFA 0021 FA00 0304 0200 06FB"
	$"2202 23FF FEFA 2203 2800 1006 FE00 0004"
	$"F500 0318 3060 0CFA 0023 FA00 0304 0204"
	$"04FB 8802 8900 02F9 8802 0810 06FE 0003"
	$"0400 0060 F800 0318 3060 0CFA 0024 FA00"
	$"0304 020C 06FB 2202 2300 02FA 2203 280C"
	$"1006 FE00 0304 0000 20F8 0003 1800 600C"
	$"FA00 23FA 0003 0402 1404 FB88 0289 0002"
	$"F988 020A 1006 FE00 0304 0000 20F8 0003"
	$"1800 600C FA00 24FA 0003 0402 27C6 FB22"
	$"0223 0002 FA22 0A28 F910 0600 1000 0400"
	$"0020 F800 0318 0060 0CFA 0023 FA00 0304"
	$"0240 44FB 8802 8900 02F9 8809 8090 0600"
	$"3000 043B 8E20 F800 0318 0060 0CFA 0024"
	$"FA00 0304 0280 46FB 2202 2303 02FA 220A"
	$"2880 5006 0050 0004 1133 20F8 0003 1FFF"
	$"E00C FA00 27FA 0003 0402 8044 FB88 0289"
	$"1F02 F988 0980 5006 3E90 0004 1121 20FC"
	$"0000 0CFE 0003 1888 A00C FA00 28FA 0003"
	$"0402 4046 FB22 0223 FE02 FA22 0A28 8090"
	$"0600 F800 040A 3F20 FC00 0004 FE00 0312"
	$"2220 0CFA 0027 FA00 0304 0227 C4FB 8802"
	$"8914 02F9 8809 F910 0600 1000 040A 2020"
	$"FC00 0004 FE00 0318 88A0 0CFA 0028 FA00"
	$"0304 0214 06FB 2202 2324 02FA 220A 280A"
	$"1006 0010 0004 0431 22FC 0000 04FE 0003"
	$"1222 200C FA00 27FA 0003 0402 0C04 FB88"
	$"0289 4802 F988 020C 1006 FE00 0304 041E"
	$"72FC 0007 E583 8D80 1888 A00C FA00 26FA"
	$"0003 0402 0406 FB22 0223 8802 FA22 0328"
	$"0810 06FE 0000 04FA 0008 0326 44C6 4012"
	$"2220 0CFA 0025 FA00 0304 0200 04FB 8802"
	$"89FF FEF9 8802 0010 06FE 0000 04FA 0008"
	$"0204 4044 4018 88A0 0CFA 001C FA00 0104"
	$"03ED FF01 F007 FEFF 00FC FA00 0802 0447"
	$"C440 1222 200C FA00 16FA 0000 04F8 0000"
	$"08E9 0008 0204 4844 4018 88A0 0CFA 0016"
	$"FA00 0004 F800 0010 E900 0803 044C C440"
	$"1222 200C FA00 16FA 0000 04F8 0000 20E9"
	$"0008 01EE 676E 6018 88A0 0CFA 0011 FA00"
	$"0004 F800 0040 E400 0312 2220 0CFA 0012"
	$"FA00 0004 F900 0101 80E4 0003 1888 A00C"
	$"FA00 11FA 0000 04F9 0000 02E3 0003 1222"
	$"200C FA00 1EFA 0000 04F9 0000 04F4 0000"
	$"07FE FF00 FCFA 0000 0FFE FF04 F818 88A0"
	$"0CFA 001C FA00 0104 03ED FF01 F007 FEFF"
	$"00FC FA00 000F FEFF 04F8 1FFF E00C FA00"
	$"2AFA 0003 0402 0004 FC88 0398 88FF FFF9"
	$"8802 0010 06FE 0000 04FE 0000 60FE 0000"
	$"0CFE 0004 0810 0020 0CFA 002A FA00 0304"
	$"0204 06FA 2202 4000 A2FB 2203 2808 1006"
	$"FE00 0404 0010 0020 FE00 000C FE00 0408"
	$"1000 200C FA00 2AFA 0003 0402 0C04 FC88"
	$"03C8 88C0 00F9 8802 0C10 06FE 0004 0400"
	$"1100 20FE 0000 0CFE 0004 0810 FC20 0CFA"
	$"002D FA00 0304 0214 06FD 2205 2322 2240"
	$"00A2 FB22 0328 0A10 06FE 0004 0400 0100"
	$"20FE 0000 0CFE 0004 0810 8420 0CFA 002B"
	$"FA00 0304 0227 C4FD 8804 8A88 88C0 40F9"
	$"880A F910 061C 0000 0437 33C7 2CFE 0008"
	$"0C08 0000 0810 8420 0CFA 002D FA00 0304"
	$"0240 46FD 2205 2622 2240 C0A2 FB22 0B28"
	$"8090 0622 0000 0419 9119 32FE 0008 0C18"
	$"0000 0810 8420 0CFA 0028 FA00 0304 0280"
	$"44FA 8801 C0C0 F988 0A80 5006 2200 0004"
	$"1091 1022 FE00 080C 0800 0008 1787 A00C"
	$"FA00 2DFA 0003 0402 8046 FD22 0532 2222"
	$"40E0 A2FB 220B 2880 5006 2200 0004 1091"
	$"1022 FE00 080C 0800 0008 1201 200C FA00"
	$"2BFA 0003 0402 4044 FD88 04E8 8888 C1E0"
	$"F988 0A80 9006 2200 0004 1091 1022 FE00"
	$"080C 0800 0008 1102 200C FA00 2DFA 0003"
	$"0402 27C6 FD22 05A2 2222 41E0 A2FB 220B"
	$"28F9 1006 2200 0004 1111 1822 FE00 080C"
	$"0800 0008 1084 200C FA00 2CFA 0003 0402"
	$"1404 FE88 0089 FE88 01C1 F0F9 880A 0A10"
	$"061C 0000 041E 38CF 73FE 0008 0C08 0000"
	$"0810 4820 0CFA 0027 FA00 0304 020C 06FA"
	$"2202 4350 A2FB 2203 280C 1006 FE00 0104"
	$"10FB 0000 0CFE 0004 0810 3020 0CFA 0029"
	$"FA00 0304 0204 04FE 8800 8CFE 8801 C240"
	$"F988 0208 1006 FE00 0104 10FB 0000 0CFE"
	$"0004 0810 0020 0CFA 002B FA00 0304 0200"
	$"06FE 2200 3AFE 2202 7FFF A2FB 2203 2800"
	$"1006 FE00 0104 10FB 0000 0CFE 0004 0810"
	$"0020 0CFA 001D FA00 0104 03ED FF01 F007"
	$"FEFF 01FC 38FB 0000 0FFE FF04 F81F FFE0"
	$"0CFA 0012 FA00 0004 FB00 0040 FD00 0040"
	$"E300 000C FA00 12FA 0000 04FB 0000 80FD"
	$"0000 40E3 0000 0CFA 0012 FA00 0004 FC00"
	$"0001 FC00 0040 E300 000C FA00 12FA 0000"
	$"04FC 0000 02FC 0000 40E3 0000 0CFA 0012"
	$"FA00 0004 FC00 000C FC00 0040 E300 000C"
	$"FA00 12FA 0000 04FC 0000 10FC 0000 40E3"
	$"0000 0CFA 0012 FA00 0004 FC00 0020 FC00"
	$"0040 E300 000C FA00 0AFA 0000 07D7 FF00"
	$"FCFA 000A FA00 0007 D7FF 00FC FA00 0AF5"
	$"0000 01FB 0000 40DB 000A F500 0006 FB00"
	$"0040 DB00 0AF5 0000 08FB 0000 40DB 000A"
	$"F500 0010 FB00 0040 DB00 0AF5 0000 20FB"
	$"0000 40DB 000A F500 0040 FB00 0040 DB00"
	$"12FD 0000 07FA FF00 80FB 0000 7FFA FF00"
	$"C0E3 0012 FD00 0004 FB00 0001 FA00 0040"
	$"FA00 0040 E300 12FD 0000 04FB 0000 01FA"
	$"0000 40FA 0000 40E3 0012 FD00 0004 FB00"
	$"0001 FA00 0040 FA00 0040 E300 12FD 0000"
	$"04FB 0000 01FA 0000 40FA 0000 40E3 0017"
	$"FD00 0704 EE0C 0040 0000 01FA 0002 4F90"
	$"0CFC 0000 40E3 0017 FD00 0704 4404 0008"
	$"0000 01FA 0002 4442 04FC 0000 40E3 0017"
	$"FD00 0704 4404 0008 0000 01FA 0002 4442"
	$"04FC 0000 40E3 0018 FD00 0704 44C4 E7DF"
	$"7000 01FA 0003 45B7 7580 FD00 0040 E300"
	$"18FD 0007 0429 2519 4920 0001 FA00 0344"
	$"1296 80FD 0000 40E3 0018 FD00 0704 29E5"
	$"1849 4000 01FA 0003 4412 8480 FD00 0040"
	$"E300 18FD 0007 0411 0518 4940 0001 FA00"
	$"0344 1284 80FD 0000 40E3 0018 FD00 0704"
	$"10EE E7EC 8000 01FA 0003 4E3B 7EC0 FD00"
	$"0040 E300 14FD 0000 04FD 0002 8000 01FA"
	$"0000 40FA 0000 40E3 0015 FD00 0004 FE00"
	$"0302 8000 01FA 0000 40FA 0000 40E3 0015"
	$"FD00 0004 FE00 0303 0000 01FA 0000 40FA"
	$"0000 40E3 0017 FD00 0004 FD00 0204 0001"
	$"FA00 0040 FD00 0320 8000 40E3 0018 FD00"
	$"0704 0240 0000 2000 01FA 0000 44FD 0003"
	$"0400 0040 E300 18FD 0007 0402 4000 0020"
	$"0001 FA00 0044 FD00 0304 0000 40E3 0019"
	$"FD00 0704 F7EC DB6F 7CED 81FA 0008 4FFE"
	$"D9F6 73EF 9DB0 40E3 0019 FD00 0704 1252"
	$"6921 2516 81FA 0008 4482 6A19 8C24 A2D0"
	$"40E3 0019 FD00 0704 725E 4927 2514 81FA"
	$"0008 448E 4911 8A24 A290 40E3 0019 FD00"
	$"0704 9250 4929 2514 81FA 0008 4492 48D1"
	$"89A4 A290 40E3 0019 FD00 0704 FB6E ECFF"
	$"BEEE C1FA 0008 47DF EF9E 7777 DDD8 40E3"
	$"0015 FD00 0004 FB00 0001 FA00 0340 0000"
	$"10FD 0000 40E3 0015 FD00 0004 FB00 0001"
	$"FA00 0340 0000 10FD 0000 40E3 0015 FD00"
	$"0004 FB00 0001 FA00 0340 0000 38FD 0000"
	$"40E3 0012 FD00 0004 FB00 0001 FA00 0040"
	$"FA00 0040 E300 12FD 0000 04FB 0000 01FA"
	$"0000 40FA 0000 40E3 0010 FD00 0007 FAFF"
	$"FA00 007F FAFF 00C0 E300 02C7 0002 C700"
	$"02C7 0002 C700 02C7 0004 C8FF 00C0 02C7"
	$"0004 C8FF 00C0 02C7 0002 C700 02C7 0002"
	$"C700 02C7 0002 C700 02C7 0002 C700 02C7"
	$"0002 C700 02C7 001D FE00 01FC 18FD 0000"
	$"18FB 0001 3002 FE00 0501 8000 0066 10FE"
	$"0000 08E6 001B FE00 0144 08FD 0000 08FB"
	$"0001 1020 FD00 0380 0000 88F9 0000 02EA"
	$"001B FE00 0140 08FD 0000 08FB 0001 1020"
	$"FD00 0380 0000 88F9 0000 02EA 0028 2401"
	$"B31C 49CB 1E05 CB78 7913 8C70 F02C CF10"
	$"7AD9 8603 1CB1 E079 FE12 C73C D989 61C0"
	$"B1E7 98E0 EC00 2824 00CC A47A 4CA1 0E3D"
	$"848B 3492 9010 7521 1026 6649 04A4 CA10"
	$"8488 3729 4266 5B92 31CA 1225 20EC 0028"
	$"2400 88B0 4A48 A104 2885 0914 9EC0 7021"
	$"E717 2244 4F07 A48A 1084 8812 2942 4449"
	$"1220 8A12 3D80 EC00 2824 0088 8C42 08A1"
	$"0428 8509 1410 3090 2109 1022 4448 0420"
	$"8A10 8488 1228 4244 4912 208A 1220 60EC"
	$"0028 2400 88A4 4608 A104 4885 1934 1090"
	$"9021 0910 2244 4804 208A 1084 8812 2842"
	$"4449 11C0 8A12 2120 EC00 2824 01DC F8FD"
	$"DCDE 079C 78EC DB8E E0F8 70EF B81F EE67"
	$"039D CDE0 79DC 3F37 3CEE 7F9A 01CD E19D"
	$"C0EC 000B FB00 0004 E900 0103 F0E8 000B"
	$"FB00 0004 E900 0102 10E8 000B FB00 000E"
	$"E900 0101 E0E8 0002 C700 02C7 0002 C700"
	$"02C7 0002 C700 02C7 0002 C700 02C7 0002"
	$"C700 00FF"
};

resource 'ICON' (500) {
	$"FFFF FFFF 8000 0001 8003 0001 8005 F001"
	$"801F 8F31 8363 80D9 8580 4379 8780 2C31"
	$"8300 30C1 8080 CD01 805B 1601 802C 1E01"
	$"803C 0C01 8018 0001 8000 0001 FFFF FFFF"
	$"B9C4 739D B9C4 739D B9C4 739D B9C4 739D"
	$"B9C4 739D B9C4 739D B9C4 739D B9C4 739D"
	$"9084 2109 9084 2109 9084 2109 9084 2109"
	$"9084 2109 9084 2109 9084 2109 FFFF FFFF"
};

resource 'ICON' (128) {
	$"FFFF FFFF 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"801C 0001 8022 0781 8001 0841 8780 0001"
	$"8FC0 E031 9FE1 F079 9BE1 7059 91E1 F031"
	$"99E0 E001 8FC0 0001 8780 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 8000 0001"
	$"8000 0001 8000 0001 8000 0001 FFFF FFFF"
};

resource 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	32768,
	32768
};

resource 'SIZE' (1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	65536,
	65536
};

resource 'SIZE' (0) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	multiFinderAware,
	backgroundAndForeground,
	dontGetFrontClicks,
	ignoreChildDiedEvents,
	is32BitCompatible,
	notHighLevelEventAware,
	onlyLocalHLEvents,
	notStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	65536,
	32768
};

resource 'vers' (2) {
	0x1,
	0x50,
	release,
	0x0,
	verFrance,
	"1.50",
	" 1987-92 GRAME"
};

data 'Echo' (0) {
	$"0B56 6572 7369 6F6E 2031 2E35"                      /* .Version 1.5 */
};

resource 'BNDL' (128, purgeable) {
	'Echo',
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'ICN#',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		},
		/* [2] */
		'FREF',
		{	/* array IDArray: 1 elements */
			/* [1] */
			0, 128
		}
	}
};

resource 'FREF' (128) {
	'APPL',
	0,
	"msEcho"
};

resource 'ICN#' (128, "echo") {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF FFFF 8000 0001 8000 0001 8000 0001"
		$"8000 0001 8000 0001 8000 0001 8000 0001"
		$"801C 0001 8022 0781 8001 0841 8780 0001"
		$"8FC0 E031 9FE1 F079 9BE1 7059 91E1 3031"
		$"99E0 E001 8FC0 0001 8780 0001 8000 0001"
		$"8000 0001 8000 0001 8000 0001 8000 0001"
		$"8000 0001 8000 0001 8000 0001 8000 0001"
		$"8000 0001 8000 0001 8000 0001 FFFF FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'ALRT' (500, "Errors") {
	{100, 100, 183, 361},
	500,
	{	/* array: 4 elements */
		/* [1] */
		OK, invisible, silent,
		/* [2] */
		OK, invisible, silent,
		/* [3] */
		OK, invisible, silent,
		/* [4] */
		OK, visible, sound1
	}
};

resource 'STR#' (500, "Errors") {
	{	/* array StringArray: 2 elements */
		/* [1] */
		"MidiShare non implant",
		/* [2] */
		"trop d'applications MidiShare"
	}
};

resource 'ics#' (128) {
	{	/* array: 2 elements */
		/* [1] */
		$"FFFF 8001 8001 81C1 8221 8001 9C19 BE3D"
		$"AE2D A619 9C01 8001 8001 8001 8001 FFFF",
		/* [2] */
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
		$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"
	}
};

resource 'icl8' (128) {
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6FB FBFB F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 FBF6 F6F6 FBF6"
	$"F6F6 F6F6 F6FB FBFB FBF6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FB"
	$"F6F6 F6F6 FBF6 F6F6 F6FB F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6B0 B0B0 B0F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 B0B0 B0B0 B0B0 F6F6 F6F6 F6F6"
	$"FDFD FDF6 F6F6 F6F6 F6F6 FDFD F6F6 F6FD"
	$"FDF6 F6B0 B0B0 B0B0 B0B0 B0F6 F6F6 F6FD"
	$"FDFD FDFD F6F6 F6F6 F6FD FDFD FDF6 F6FD"
	$"FDF6 F6B0 B000 B0B0 B0B0 B0F6 F6F6 F6FD"
	$"00FD FDFD F6F6 F6F6 F6FD 00FD FDF6 F6FD"
	$"FDF6 F6B0 0000 00B0 B0B0 B0F6 F6F6 F6FD"
	$"0000 FDFD F6F6 F6F6 F6F6 FDFD F6F6 F6FD"
	$"FDF6 F6B0 B000 00B0 B0B0 B0F6 F6F6 F6F6"
	$"FDFD FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 B0B0 B0B0 B0B0 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6B0 B0B0 B0F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6"
	$"F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
};

resource 'icl4' (128) {
	$"EEEE EEEE EEEE EEEE EEEE EEEE EEEE EEEE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCE EECC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCEC CCEC CCCC CEEE ECCC CCCE"
	$"ECCC CCCC CCCC CCCE CCCC ECCC CECC CCCE"
	$"ECCC C555 5CCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC 5555 55CC CCCC EEEC CCCC CCEE CCCE"
	$"ECC5 5555 555C CCCE EEEE CCCC CEEE ECCE"
	$"ECC5 5055 555C CCCE 0EEE CCCC CE0E ECCE"
	$"ECC5 0005 555C CCCE 00EE CCCC CCEE CCCE"
	$"ECC5 5005 555C CCCC EEEC CCCC CCCC CCCE"
	$"ECCC 5555 55CC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC C555 5CCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCC CCCC CCCC CCCC CCCE"
	$"EEEE EEEE EEEE EEEE EEEE EEEE EEEE EEEE"
};

resource 'ics8' (128) {
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6FB FBFB F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 FBF6 F6F6 FBF6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6B0 B0B0 F6F6 F6F6 F6AB ABF6 F6FD"
	$"FDF6 B0B0 B0B0 B0F6 F6F6 ABAB ABAB F6FD"
	$"FDF6 B000 B0B0 B0F6 F6F6 AB00 ABAB F6FD"
	$"FDF6 B000 00B0 B0F6 F6F6 F6AB ABF6 F6FD"
	$"FDF6 F6B0 B0B0 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDF6 F6F6 F6F6 F6F6 F6F6 F6F6 F6F6 F6FD"
	$"FDFD FDFD FDFD FDFD FDFD FDFD FDFD FDFD"
};

resource 'ics4' (128) {
	$"EEEE EEEE EEEE EEEE ECCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCE ECCC CCCE EECC CCCE"
	$"ECCC CCEC CCEC CCCE ECCC CCCC CCCC CCCE"
	$"ECC5 55CC CCCE ECCE EC55 555C CCEE EECE"
	$"EC50 555C CCE0 EECE EC50 055C CCCE ECCE"
	$"ECC5 55CC CCCC CCCE ECCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCE ECCC CCCC CCCC CCCE"
	$"ECCC CCCC CCCC CCCE EEEE EEEE EEEE EEEE"
};

data 'cicn' (128) {
	$"0000 0000 8010 0000 0000 0020 0020 0000"            /* .......... . .. */
	$"0000 0000 0000 0048 0000 0048 0000 0000"            /* .......H...H.... */
	$"0004 0001 0004 0000 0000 0000 0000 0000"            /* ................ */
	$"0000 0000 0000 0004 0000 0000 0020 0020"            /* ............. .  */
	$"0000 0000 0004 0000 0000 0020 0020 0000"            /* ........... . .. */
	$"0000 FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF FFFF FFFF FFFF FFFF FFFF"            /* ................ */
	$"FFFF FFFF FFFF 8000 0001 8000 0001 8000"            /* ............. */
	$"0001 8000 0001 8000 0001 8000 0001 8000"            /* ............ */
	$"0001 801C 0001 8022 0781 8001 0841 8780"            /* ....."...A */
	$"0001 8FC0 E031 9FE1 F079 9BE1 7059 91E1"            /* ...1..y.pY. */
	$"3031 99E0 E001 8FC0 0001 8780 0001 8000"            /* 01........ */
	$"0001 8000 0001 8000 0001 8000 0001 8000"            /* ............ */
	$"0001 8000 0001 8000 0001 8000 0001 8000"            /* ............ */
	$"0001 8000 0001 8000 0001 8000 0001 FFFF"            /* ............. */
	$"FFFF 0000 0000 0000 0005 0000 FFFF FFFF"            /* ................ */
	$"FFFF 0001 3333 0000 9999 0002 3333 3333"            /* ....33....3333 */
	$"6666 0003 DDDD DDDD DDDD 0004 5555 5555"            /* ff..........UUUU */
	$"5555 0005 2222 2222 2222 5555 5555 5555"            /* UU..""""""UUUUUU */
	$"5555 5555 5555 5555 5555 5333 3333 3333"            /* UUUUUUUUUUS33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3334"            /* 3333333335S33334 */
	$"4433 3333 3333 3333 3335 5333 3333 3343"            /* D333333335S3333C */
	$"3343 3333 3444 4333 3335 5333 3333 3333"            /* 3C334DC335S33333 */
	$"3334 3333 4333 3433 3335 5333 3111 1333"            /* 3433C34335S31..3 */
	$"3333 3333 3333 3333 3335 5333 1111 1133"            /* 3333333335S3...3 */
	$"3333 2223 3333 3322 3335 5331 1111 1113"            /* 33"#333"35S1.... */
	$"3332 2222 3333 3222 2335 5331 1011 1113"            /* 32""332"#5S1.... */
	$"3332 0222 3333 3202 2335 5331 0001 1113"            /* 32."332.#5S1.... */
	$"3332 0022 3333 3322 3335 5331 1001 1113"            /* 32."333"35S1.... */
	$"3333 2223 3333 3333 3335 5333 1111 1133"            /* 33"#333335S3...3 */
	$"3333 3333 3333 3333 3335 5333 3111 1333"            /* 3333333335S31..3 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5333 3333 3333"            /* 3333333335S33333 */
	$"3333 3333 3333 3333 3335 5555 5555 5555"            /* 3333333335UUUUUU */
	$"5555 5555 5555 5555 5555"                           /* UUUUUUUUUU */
};

